<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Database;

use Exception;
use InvalidArgumentException;
use Symfony\Component\Yaml\Yaml;

if (!function_exists('decrypt_pass')) {
    function decrypt_pass($password)
    {
        #Decrypt DB password
        $command = sprintf("python3 /opt/cyops/scripts/manage_passwords.py --decrypt '" . $password . "' 'jQp3(7@jod#j38d1'");
        exec($command, $output, $errorCode);
        if (!$errorCode) {
            $output = $output[0];
            $length = strlen('Password:');
            if (substr($output, 0, $length) === 'Password:') {
                $password = substr($output, strlen('Password:'), strlen($output));
            } else {
                throw new Exception('DB Password decrypt failed with error %s' % $output);
            }
        }
        return $password;
    }
}

$ymlParsedFile = Yaml::parse(file_get_contents('/opt/cyops/configs/database/db_config.yml'));

$postgresHost = isset($ymlParsedFile['postgres']['pg_host']) ? $ymlParsedFile['postgres']['pg_host'] : '127.0.0.1';
$postgresPort = isset($ymlParsedFile['postgres']['pg_port']) ? $ymlParsedFile['postgres']['pg_port'] : '5432';
$postgresUsername = isset($ymlParsedFile['postgres']['pg_user']) ? $ymlParsedFile['postgres']['pg_user'] : 'cyberpgsql';
$postgresPassword = $ymlParsedFile['postgres']['pg_password'];
$postgresPassword = decrypt_pass($postgresPassword);
if ($container) {
    $container->setParameter('pg_host', $postgresHost);
    $container->setParameter('pg_port', $postgresPort);
    $container->setParameter('pg_user', $postgresUsername);
    $container->setParameter('pg_password', base64_encode($postgresPassword));

    try {
        $versionJsonFile = file_get_contents('/opt/cyops-api/public/version.json');
        $versionContent = json_decode($versionJsonFile, true);
        $version = explode('-', $versionContent['version'])[0];
        $container->setParameter('product_version', $version);
    } catch (InvalidArgumentException | \Exception $e) {
        $container->setParameter('product_version', 'dev');
    }
}
