<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Command;

use App\Backup\Core\FolderBackupProcessor;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Style\SymfonyStyle;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Command\LockableTrait;
use Symfony\Component\Console\Output\OutputInterface;

class CleanupAllCommand extends Command
{

    use LockableTrait;

    protected $folderBackupProcessor;

    public function __construct(FolderBackupProcessor $folderBackupProcessor)
    {
        $this->folderBackupProcessor = $folderBackupProcessor;
        parent::__construct();
    }

    protected function configure()
    {
        $this
            ->setName('app:cleanup:all')
            ->setAliases(['cybersponse:cleanup:all'])
            ->setDescription('Performs a system cleanup using all processors.');
    }

    protected function execute(InputInterface $input, OutputInterface $output): int
    {
        $io = new SymfonyStyle($input, $output);
        $result = $this->folderBackupProcessor->onSuccess();
        if ($result) {
            $io->success('Finished with system cleanup!');
        } else {
            $io->error("Error: app:cleanup:all failed to execute. Check prod.log file for more info.");
            return Command::FAILURE;
        }
        return Command::SUCCESS;
    }
}
