<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Command;

use Symfony\Component\Filesystem\Filesystem;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

class PublishUnlockCommand extends Command
{
    protected $filesystem;

    public function __construct(protected ContainerInterface $container)
    {
        parent::__construct();
    }

    protected function configure()
    {
        $this
            ->setName('app:publish:unlock')
            ->setAliases(['cybersponse:publish:unlock'])
            ->setDescription('Unset 503 on the current node.')
            ->setHelp("This command allows you to unlock api requests by unsetting 503.json.");

        $this->filesystem = new Filesystem();
    }


    protected function execute(InputInterface $input, OutputInterface $output)
    {

        $output->writeln([
            '===========================================================',
            'UnLocking the API request',
            '===========================================================',
            '',
        ]);
        $rootDir = $this->container->getParameter('kernel.project_dir');
        $logDir = sprintf('%s/public', $rootDir);

        $this->filesystem->remove(sprintf('%s/503.json', $logDir));

        $output->writeln([
            '===========================================================',
            'API request UnLocked',
            '===========================================================',
            '',
        ]);
        return Command::SUCCESS;
    }
}
