<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Command;

use App\Backup\Core\FolderBackupProcessor;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Style\SymfonyStyle;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Command\LockableTrait;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Component\Filesystem\Exception\IOException;

class RestoreAllCommand extends Command
{
    use LockableTrait;

    public function __construct(protected FolderBackupProcessor $folderBackupProcessor)
    {
        parent::__construct();
    }

    protected function configure()
    {
        $this
            ->setName('app:restore:all')
            ->setAliases(['cybersponse:restore:all'])
            ->setDescription('Performs a system restore using all processors.');
    }

    protected function execute(InputInterface $input, OutputInterface $output): int
    {
        $io = new SymfonyStyle($input, $output);
        try {
            $this->folderBackupProcessor->restore();
        } catch (IOException | \Exception $exception) {
            $io->error($exception->getMessage());
            return $exception->getCode();
        }
        $io->success('Finished with system restore!');

        return Command::SUCCESS;
    }
}
