<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Command;

use InvalidArgumentException;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

class SolutionPackUtilityCommand extends Command
{
    public function __construct(private EntityManagerInterface $entityManager)
    {
        parent::__construct();
    }

    protected function configure()
    {
        $this
            ->setName('app:sp:update')
            ->setAliases(['fortisoar:sp:update'])
            ->setDescription('Utilties for solution pack.')
            ->setDefinition([
                new InputOption(
                    'solutionPackName',
                    'spName',
                    InputOption::VALUE_REQUIRED,
                    'Arguments for getting solution pack name to be marked as installed.'
                ),
                new InputOption(
                    'markInstalled',
                    'mi',
                    InputOption::VALUE_NONE,
                    'Arguments for getting solution pack name to be marked as installed.'
                )
            ]);
    }

    protected function execute(InputInterface $input, OutputInterface $output): int
    {
        $solutionPackName = $input->getOption('solutionPackName');
        if ($input->getOption('markInstalled')) {
            $sql = "update solutionpacks set installed=true, status='Completed' where type='solutionpack' and name='$solutionPackName'";
            try {
                $this->entityManager->getConnection()->prepare($sql)->executeQuery();
                $output->writeln([sprintf('Solution pack "%s" marked as installed', $solutionPackName)]);
            } catch (InvalidArgumentException | \Exception $e) {
                $output->writeln(['Updating solution pack module failed']);
                $output->writeln([$e->getMessage()]);
                return Command::FAILURE;
            }
        }
        return Command::SUCCESS;
    }
}
