<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Command;

use JsonSerializable;

class SystemUpdate implements \JsonSerializable
{
    /** @var string */
    protected $message;

    /** @var int */
    protected $progressPercent;

    /** @var int */
    protected $startTime;

    /**
     * SystemUpdate constructor.
     */
    public function __construct()
    {
        $this->startTime = time();
    }

    /**
     * @inheritdoc
     */
    public function jsonSerialize()
    {
        return [
            '@type' => 'SystemUpdate',
            'code' => 503,
            'message' => $this->message,
            'progressPercent' => $this->progressPercent,
            'startTime' => $this->startTime
        ];
    }

    /**
     * @param string $message
     * @return SystemUpdate
     */
    public function setMessage($message)
    {
        $this->message = $message;
        return $this;
    }

    /**
     * @param int $progressPercent
     * @return SystemUpdate
     */
    public function setProgressPercent($progressPercent)
    {
        $this->progressPercent = $progressPercent;
        return $this;
    }

    /**
     * @param int $startTime
     * @return SystemUpdate
     */
    public function setStartTime($startTime)
    {
        $this->startTime = $startTime;
        return $this;
    }
}
