<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Conditional;

use Symfony\Component\Serializer\Annotation\Groups;


/**
 * Class Query
 *
 * @Annotation
 * @Target({"PROPERTY","ANNOTATION"})
 *
 * @package App\Conditional
 */
class Query implements QueryInterface
{
    /**
     * @Groups({"metadata"})
     * @var string
     */
    public $logic;

    /**
     * @Groups({"metadata"})
     * @var mixed
     */
    public $result;

    /**
     * @Groups({"metadata"})
     * @var array
     */
    public $filters;

    /**
     * @return string
     */
    public function getLogic()
    {
        return $this->logic;
    }

    /**
     * @return mixed
     */
    public function getResult()
    {
        return $this->result;
    }

    /**
     * @return array
     */
    public function getFilters()
    {
        return $this->filters;
    }
}

