<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Constants;


class AppConstants
{
  public const NORMALIZER_METHOD = 'jsonld';
  public const BATCH_SIZE_FOR_BULK = 30;
  public const WORKFLOW_EXECUTION_KEY = 'cyops.workflow.execute';
  public const FILE_IRI = "/api/3/files/";
  public const CONTENTHUB_URL = "/content-hub/";
  public const CONTENTHUB_METADATA_JSON = "content-hub.json";
  public const DEFALUT_KEY = 'cyops.crudhub.datanotify';
  public const STATUS = array(
    "DRAFT" => "Draft",
    "GENERATING_OPTIONS" => "Generating Options",
    "OPTIONS_GENERATED" => "Reviewing",
    "IMPORTING" => "In Progress",
    "PUBLISHING" => "Publishing Modules",
    "ERROR" => "Error",
    "IMPORT_COMPLETE" => "Import Complete"
  );
  public const CONFIG_TYPES = array(
    "picklistNames" => "fsr.core.service.picklist_name_config",
    "modules" => "fsr.core.service.module_config",
    "viewTemplates" => "fsr.core.service.view_config",
    "views" => "fsr.core.service.view_config",
    "roles" => "fsr.core.service.role_config",
    "actors" => "fsr.core.service.actor_config",
    "teams" => "fsr.core.service.team_config",
    "playbooks" => "fsr.core.service.playbook_config",
    "playbookBlocks" => "fsr.core.service.playbook_block_config",
    "rules" => "fsr.core.service.rule_config",
    "ruleChannels" => "fsr.core.service.rule_config",
    "reports" => "fsr.core.service.report_config",
    "dashboards" => "fsr.core.service.dashboard_config",
    "connectors" => "fsr.core.service.connector_config",
    "widgets" => "fsr.core.service.widget_config",
    "recordSets" => "fsr.core.service.record_set_config",
    "appSettings" => "fsr.core.service.app_settings_config",
  );
  public const TRAITS_ATTRIBUTES = ['id', 'createDate', 'modifyDate', 'createUser', 'modifyUser', 'sattrib', 'importedBy', 'lastModifyDate'];
  public const STIX_TRAITS_ATTRIBUTES = ['createDate', 'modifyDate', 'createUser', 'modifyUser', 'sattrib', 'importedBy', 'lastModifyDate'];
  public const INVALID_CHAR_IN_TAG = "Special characters '#', '?', ',', '\'', '\"' and '/' are not allowed in tag.";

  public const DELTA_DATA = 'data';
  public const HTTP_METHOD = 'operation';
  public const REMOTE_ADDR = 'source';
  public const WEB_SOCKET_SESSION_ID = 'websocketId';
  public const COMPONENT = 'component';
  public const ENTITY_TYPE = 'entityType';
  public const OPERATION = 'operation';
  public const USER_UUID = 'userId';
  public const USER = 'user';
  public const TRANSACTION_DATE = 'transactionDate';
  public const DEFAULT_KEY = 'cyops.crudhub.datanotify';
  public const ENTITY_UUID = 'entityUuid';
  public const ELASTIC_SEARCH_OPERATION_KEY = 'esoperation';
  public const SOLUTIONPACK_TYPE = 'solutionpack';
  public const MULTICONTENT_TYPE = 'multiContent';
  public const TMP_SAFE_PATH = '/tmp/';
  public const MIN_TAG_LENGTH = 2;
  public const FILE_NAME_CLEANUP_REGEX = '/[\*\/\\\?\<\>\:\"\'\|]/';
  public const CRUDHUB_PARAMETER_KEY = 'crudhub.uri';
  public const REQUIRED_MIN_SPACE_PUBLISH = 100; //100MB
  public const BYTES_TO_MB_DENOMINATOR = 1048576; //1024*1024
  public const FSR_MIN_COMPATIBILITY = 'fsrMinCompatibility';

  public const METHOD_MAP = [
    "post" => "create",
    "put" => "update",
    "delete" => "delete"
  ];
  public const TOTAL_RESTRICTED_FEEDS_COUNT = 100;
  public const TOTAL_INGESTION_FEEDS_LIMIT = 1000;
  public const TOTAL_RESTRICTED_COLLECTIONS_COUNT = 3;
  public const TOTAL_RESTRICTED_FEEDS_PAGE = 1;
  public const MASTER_ROLE_NAME = 'master';
  public const FEED_COUNT = 'feed_count';

  public const LATEST_FEED_QUERY = "SELECT createdate from ";
  public const ACTION = 'action';
  public const METHOD = 'method';
  public const PLAYBOOK_IRI = 'playbookIri';
  public const PLAYBOOK_NAME = 'playbookName';
  public const TITLE = 'title';

  public const PUBLISH_IGNORE_ATTRIBUTES = ['importedBy', 'orderIndex', 'gridColumn', 'bulkAction', 'tooltip', 'visibility', 'recommend', 'dataSourceFilters', 'identifier', 'readable', 'system', 'searchable', 'htmlEscape', 'defaultValue'];
  public const CUSTOM_DATE_DEFAULT_VALUE_IDENTIFIER = '%22differenceType%22';

  public const IGNORE_TAG_FOR_SUGGESTION = 'excludefromsuggestion';
  public const WORKFLOW_STEP_TYPES_IRI_MAP = [
    "WorkflowReference" => "/api/3/workflow_step_types/74932bdc-b8b6-4d24-88c4-1a4dfbc524f3"
  ];
  public const CACHE_EXPIRY_FOR_LICENSE = 7200;
  public const IGNORE_MISSING_RELATIONSHIP = '$ignore_missing_relations';
  public const CUSTOM_MODULE_IDENTIFIER = 'App\Entity\Custom';

  # Indicating request for record is directly invoked on current node.
  public const SOURCE_ORIGIN = 'origin';
  
  # Indicating request for record is invoked by replication service on current node
  public const SOURCE_REPLICATE = 'replicate';
  
  # Flag is used to indicate that record is coming in system as part of replication invoked by replication service.
  public const IS_REPLICATION_FLAG = 'isReplication';

  public const WIDGET_ALLOWED_FILE_EXTENSIONS = ['js', 'html', 'css', 'json', 'txt', 'ttf', 'svg'];

  public const PARAM_CONTENT_HUB_REQ_CHUNK_SIZE = "content_hub_request_chunk_size";
  public const DEFAULT_CONTENT_HUB_CHUNK_SIZE = 100;

}
