<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Constants;


class ErrorConstants
{
  public const TAXII_SERVER_DISABLED = 'TAXII Server is currently disabled, contact system admin to enable it';
  public const DEPENDENCY_FAILED = 'Cannot proceed as installation of dependent solution pack[s] failed';
  public const CUSTOM_DEPENDENCY_FAILED = 'Cannot proceed as a custom dependent solution pack is not installed. Please install the dependent solution pack manually and try again';

  // Advance Query Controller -> queryAssociationAction
  public const FIELD_MISSING = 'There is no field: %s in the resource class %s';

  // Agent Controller
  public const AGENT_ID_EXISTS = "AgentId: %s already exists, use different AgentId";
  public const AGENT_NAME_EXISTS = "Agent Name: %s already exists, use different Agent Name";
  public const INVALID_CLIENT_CERT = 'Invalid client certificate. The extended key usage attribute in certificate must have the client authentication.';
  public const SELF_AGENT_ADD_DETECTED = 'Self Agent cannot be added';
  public const DB_PASSWORD_DECRYPT_FAILED = 'DB Password decrypt failed with error: %s';

  //Bulk Create Controller
  public const RESOURCE_DOES_NOT_MATCH = 'The resource in the record IRIs does not match the resource in API route';

  // Comment Controller
  public const COMMENT_MODIFICATION_BLOCKED = 'Modification of comments has been blocked by your administrator.';
  public const MESSAGE_MODIFICATION_NOT_ALLOWED = 'Modification not permitted. Either the comment has been deleted, or you do not have permissions to edit this comment.';
  public const COMMENT_DELETE_NOT_ALLOWED = 'Deletion of comments has been blocked by your administartor';
  public const MESSAGE_DELETE_NOT_ALLOWED = 'You do not have permissions to edit the comment record, or you have exceeded the permitted edit time window';

  // TypeAgnosticResourceController
  public const TYPE_MUST_BE_SPECIFIED = 'The "@type" must be specified for all models.';
  public const UPSERT_NOT_SUPPORTED = 'Upsert Operation for %s modules is not supported.';

  // Files Controller
  public const INVALID_FILE_NAME = 'Invalid file name specified';
  public const INSUFFICIENT_SPACE_FOR_PUBLISH = "ERROR: Not enough space available. Minimum free space required is %d mb and available space is %d mb in %s";

  public const TIM_QUERY_ROUTE_RESTRAINT = 'Ensure TIM SKU is enabled for this endpoint to work';

  public const IMPROPER_RELATION_DEFINATION = 'Correspondig reverse mapping for module does not exists';

  // QueryResourceController
  public const RECORD_NOT_EXISTS = 'Record with Provided UUID does not exists';

  // PeopleSubscriber
  public const INVALID_UUID_PROVIDED = 'Invalid UUID provided for %s';

  public const SME_IS_IN_USE = 'The Secure Message Exchange is currently being used for communication with %s agent(s) and, therefore, cannot be deleted. You must first use another Secure Message Exchange server for communication with these agents';
}
