<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Controller\Settings;

use App\Utility\Resolver;
use InvalidArgumentException;
use App\Entity\Settings\SystemSettings;
use App\Repository\SystemSettingsRepository;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
use Symfony\Component\HttpKernel\Exception\BadRequestHttpException;

/**
 * Class PublicSettingsController
 */
class PublicSettingsController extends AbstractController
{
    /**
     * @Route(
     *     name="get_settings_authentication_message",
     *     path="/api/public/settings/authentication",
     *     methods={"GET"}
     * )
     */
    public function getAction()
    {
        // TODO: Don't hardcode this
        $path = 'authentication';
        $documentManagerRegistry = $this->getDoctrine();
        $systemSettingsManager = $documentManagerRegistry->getManagerForClass(SystemSettings::class);

        /** @var SystemSettingsRepository $systemSettingsRepository */
        $systemSettingsRepository = $systemSettingsManager->getRepository(SystemSettings::class);
        $systemSettings = $systemSettingsRepository->findAll();
        if (!$systemSettings) {
            throw new BadRequestHttpException('No System Settings Identified');
        }
        $systemSettings = $systemSettings[0];
        $systemSettingsValues = $systemSettings->getPrivateValues();

        try {
            $resolvedValues = Resolver::get($systemSettingsValues, $path);
        } catch (InvalidArgumentException | \Exception $e) {
            throw new NotFoundHttpException('Not Found');
        }

        return new JsonResponse($resolvedValues);
    }
}
