<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Controller;

use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\Routing\Annotation\Route;

class SystemEntitiesMetadataController extends AbstractController
{
    /**
     * @Route("/api/system/fixtures/{moduletype?}", name="api_system_entities_fixtures", methods={"GET"})
     */
    public function getSystemEntitesFixtures(Request $request, $moduletype = null)
    {
        $systemFixturesFile = file_get_contents('/opt/cyops-api/src/StaticFile/SystemFixtures.json');
        $systemFixture = json_decode($systemFixturesFile);
        if ($moduletype) {
            return new JsonResponse($systemFixture->{$moduletype}, Response::HTTP_OK);
        }
        $fixtures = [];
        foreach ($systemFixture as $fixture) {
            $fixtures[] = $fixture;
        }
        return new JsonResponse($fixtures);
    }
}
