<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Doctrine\DBAL;

use Doctrine\Common\EventManager;
use Doctrine\DBAL\Schema\Index;
use Doctrine\DBAL\Schema\Table;
use Doctrine\DBAL\Platforms\PostgreSQL100Platform;

class PostgresSQLPlatformExt extends PostgreSQL100Platform
{

    public function __construct(EventManager $eventManager)
    {
        $this->_eventManager = $eventManager;
    }

    public function getCreateIndexSQL(Index $index, $table)
    {
        if (!$index->hasFlag('gin_search')) {
            return parent::getCreateIndexSQL($index, $table);
        }

        if ($table instanceof Table) {
            $table = $table->getQuotedName($this);
        }

        $table = sprintf('%s USING GIN', $table);

        return parent::getCreateIndexSQL($index, $table);
    }
}
