<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Doctrine\ORM;

use Doctrine\ORM\Query\Expr;

class JsonExpressionBuilder extends Expr
{
    public function jsonContains($key, $json)
    {
        $function = new Expr\Func('JSONB_AG', [$key, $json]);
        return $this->eq($function, 'TRUE');
    }

    public function jsonExists($key, $jsonQuery, $json)
    {
        $jsonSelects = $key;
        foreach ($jsonQuery as $field) {
            $jsonSelects = new Expr\Func('JSONB_SELECT', [$jsonSelects, '\'' . $field . '\'']);
        }
        $function = new Expr\Func('JSONB_EX', [$jsonSelects, $json]);
        return $this->eq($function, 'TRUE');
    }

    public function jsonLike($key, $jsonQuery, $value)
    {
        $hgg = new Expr\Func('JSONB_HGG', [$key, '\'{' . implode(',', $jsonQuery) . '}\'']);
        $lower = new Expr\Func('TEXT_LOWER', [$hgg]);
        return new Expr\Comparison($lower, 'LIKE', $value);
    }
}
