<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */
 namespace App\Doctrine\ORM;

 use Doctrine\ORM\Query\AST\Functions\FunctionNode;
 use Doctrine\ORM\Query\Lexer;
 use Doctrine\ORM\Query\Parser;
 use Doctrine\ORM\Query\SqlWalker;

/**
 * ArrayOverlapFunction ::= "ARRAY_OVERLAP" "(" StringPrimary "," StringPrimary ")"
 */
class VarcharArrayOverlap extends FunctionNode
{
    protected $firstStringArray = null;
    protected $secondStringArray = null;
    protected $operator = '&&';

    /**
     * @override
     */
    public function parse(Parser $parser)
    {
        $parser->match(Lexer::T_IDENTIFIER);
        $parser->match(Lexer::T_OPEN_PARENTHESIS);
        $this->firstStringArray = $parser->StringPrimary();
        $parser->match(Lexer::T_COMMA);
        $this->secondStringArray = $parser->StringPrimary();
        $parser->match(Lexer::T_CLOSE_PARENTHESIS);
    }

    /**
     * @override
     */
    public function getSql(SqlWalker $sqlWalker)
    {
        return "(" . $this->firstStringArray->dispatch($sqlWalker) . " && " .
            $this->secondStringArray->dispatch($sqlWalker) . ")";
    }
}