<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Encoder\Hmac;

use Symfony\Component\Security\Core\Authentication\Token\AbstractToken;

class HmacUserToken extends AbstractToken
{
    /** @var string */
    protected $payload;

    /**
     * {@inheritdoc}
     */
    public function __construct(array $roles = array())
    {
        parent::__construct($roles);

        $this->setAuthenticated(!empty($roles));
    }

    /**
     * @param string $payload
     */
    public function setPayload($payload)
    {
        $this->payload = $payload;
    }

    public function getCredentials()
    {
        return $this->payload;
    }
}
