<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */
namespace App\Encoder;


use GuzzleHttp\Client;

abstract class ProxyClient extends Client
{
    /** @var string */
    protected $targetUri;

    /** @var string */
    protected $routePrefix;

    /**
     * @return string
     */
    public function getTargetUri()
    {
        return $this->targetUri;
    }

    /**
     * @param string $targetUri
     */
    public function setTargetUri($targetUri)
    {
        $this->targetUri = $targetUri;
    }

    /**
     * @return string
     */
    public function getRoutePrefix()
    {
        return $this->routePrefix;
    }

    /**
     * @param string $routePrefix
     */
    public function setRoutePrefix($routePrefix)
    {
        $this->routePrefix = $routePrefix;
    }

    /**
     * @param array $arguments
     * @return mixed
     */
    abstract public function setArguments($arguments);
}
