<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Entity\Base;

use Symfony\Component\Serializer\Annotation\Groups;
use ApiPlatform\Core\Annotation\ApiProperty;

/**
 * @Doctrine\ORM\Mapping\MappedSuperclass
 * @Doctrine\ORM\Mapping\HasLifecycleCallbacks
 */
abstract class UuidBasedBaseEntity extends BaseEntity
{
    /**
     * @ApiProperty(identifier=true)
     * @Doctrine\ORM\Mapping\Id
     * @Doctrine\ORM\Mapping\Column(name="uuid", type="uuid", nullable=false)
     * @Groups({"fsr_primary", "fsr_all", "uuid"})
     */
    protected $uuid;

    /**
     * Set uuid
     *
     * @return BaseEntity
     */
    public function setUuid($uuid)
    {
        $this->uuid = $uuid;

        return $this;
    }

    /**
     * Get uuid
     *
     */
    public function getUuid()
    {
        if ($this->uuid) {
            return strval($this->uuid);
        }
        return $this->uuid;
    }
}
