<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Entity\Core;

use ApiPlatform\Core\Annotation\ApiResource;
use App\Repository\ImageRepository;
use App\Traits\Ownable;
use App\Traits\UserOwnable;
use Doctrine\ORM\Mapping as ORM;

/**
 *  @ApiResource(
 *     attributes={"validation_groups"={"fsr_primary", "fsr_all"},"fsr_type"="images", "fsr_module"="application", "fsr_singular"="image"},
 *     denormalizationContext={"groups"={"fsr_all", "password"}, "fetch_data"=false},
 *     collectionOperations={
 *          "get" = { "security_post_denormalize" = "is_granted('read.application', object)" },
 *          "post" = { "security_post_denormalize" = "is_granted('create.application', object)" }
 *     },
 *     itemOperations={
 *          "get" = { "security" = "is_granted('read.application', object)" },
 *          "put" = { "security" = "is_granted('update.application', object)" },
 *          "delete" = { "security" = "is_granted('delete.application', object)" }
 *     }
 * )
 * @ORM\Table(name="images")
 * @ORM\Entity(repositoryClass=ImageRepository::class)
 */

class Image extends AbstractFile
{
    use Ownable;
    use UserOwnable;
    
    public function uuid()
    {
        return $this->uuid;
    }
}
