<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Entity\ModelMetadata;

use App\Entity\Base\BaseEntity;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Serializer\Annotation\Groups;

/**
 * @ORM\MappedSuperclass
 * @ORM\HasLifecycleCallbacks
 */
abstract class Metadatas extends BaseEntity
{
    /**
     * @Groups({"fsr_primary", "fsr_all"})
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $displayName;

    /**
     * @Groups({"fsr_primary", "fsr_all"})
     * @ORM\Column(type="json", nullable=true)
     */
    private $descriptions = [];

    public function getDisplayName(): ?string
    {
        return $this->displayName;
    }

    public function setDisplayName(?string $displayName): self
    {
        $this->displayName = $displayName;

        return $this;
    }

    public function getDescriptions()
    {
        return $this->descriptions;
    }

    public function setDescriptions(?array $descriptions): self
    {
        $this->descriptions = $descriptions;

        return $this;
    }


 	// /**
    //  * @Symfony\Component\Validator\Constraints\Callback
    //  */
    // public function isPluralValid(ExecutionContextInterface $context)
    // {
    //     if (array_key_exists('plural', $this->descriptions)) {
    //         $validator = $context->getValidator();
    //         $constraintViolations = $validator->validate($this->descriptions['plural'], [new NotBlank()]);
    //         foreach ($constraintViolations as $constraintViolation) {
    //             //Wrap violation with new context
    //             $context
    //                 ->buildViolation($constraintViolation->getMessage())
    //                 ->setCause($constraintViolation->getCause())
    //                 ->atPath('descriptions.plural')
    //                 ->setCode($constraintViolation->getCode())
    //                 ->setInvalidValue($constraintViolation->getInvalidValue())
    //                 ->setParameters($constraintViolation->getParameters())
    //                 ->setPlural($constraintViolation->getPlural())
    //                 ->addViolation();
    //         }
    //     }

    //     if (array_key_exists('singular', $this->descriptions)) {
    //         if ($this->isKeyword($this->descriptions['singular'])) {
    //             $value = $this->descriptions['singular'];
    //             $context
    //                 ->buildViolation("Invalid name- singular : " . "\"$value\"" . "conflicts with reserved keywords.")
    //                 ->setCause("Reserved PHP keyword")
    //                 ->setCode(22)
    //                 ->setPlural(22)
    //                 ->addViolation();
    //         }
    //     }
    // }

private function isKeyword($singular)
    {
        $keywords = array('__halt_compiler', 'abstract', 'and', 'array', 'as', 'break', 'callable', 'case', 'catch', 'clone', 'const', 'continue', 'declare', 'default', 'die', 'do', 'echo', 'else', 'elseif', 'empty', 'enddeclare', 'endfor', 'endforeach', 'endif', 'endswitch', 'endwhile', 'eval', 'exit', 'extends', 'final', 'for', 'foreach', 'function', 'global', 'goto', 'if', 'implements', 'include', 'include_once', 'instanceof', 'insteadof', 'interface', 'isset', 'list', 'namespace', 'new', 'or', 'print', 'private', 'protected', 'public', 'require', 'require_once', 'return', 'static', 'switch', 'throw', 'trait', 'try', 'unset', 'use', 'var', 'while', 'xor', 'class', 'files', 'file', 'staging_model_metadatas', 'staging_model_metadata', 'attribute_metadatas', 'attribute_metadata', 'model_metadatas', 'model_metadata', 'attrib_model_metadata', 'attrib_model_metadatas', 'cyops', 'system_settings', 'system_setting', 'user_settings', 'user_setting', 'generic_template', 'generic_templates', 'queries', 'system_view_template', 'system_view_templates', 'user_view_template', 'user_view_templates', 'emailTemplate', 'emailTemplates', 'proxy', 'secret', 'workflow', 'workflows', 'team', 'role', 'pgfile');
        if (in_array(strtolower($singular), $keywords)) {
            if (method_exists($this, 'getType')) {
                $type = $this->getType();
                if ($type !== 'picklists') {
                    return true;
                }
            }
        }
        return false;
    }
}
