<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Entity\ThreatIntel;

use App\Entity\Base\UuidBasedBaseEntity;
use Symfony\Component\Serializer\Annotation\Groups;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\MappedSuperclass
 * @ORM\EntityListeners({"App\EventSubscriber\ThreatIntelListener"})
 */
abstract class ThreatIntelBase extends UuidBasedBaseEntity
{
    /**
     * @ORM\Column(name="value_tokens", type="varchar_array", nullable=true)
     * @Groups({"value_tokens"})
     */
    protected $valueTokens;

    /**
     * @Groups({"fsr_primary", "fsr_all", "spec_version"})
     */
    public function getSpecVersion()
    {
        return "2.1";
    }

    /**
     * @Groups({"fsr_primary", "fsr_all", "id"})
     */
    public function getId()
    {
        if (method_exists($this, 'getSourceId')) {
            // Source ID Field is defined in child module of threat Intel Base
            // This might show error in editor but will not fail
            return $this->getSourceId();
        } else {
            return $this->getUuid();
        }
    }

    /**
     * @Groups({"fsr_primary", "fsr_all", "type"})
     */
    public function getFeedType()
    {
        return "indicator";
    }

    /**
     * @Groups({"fsr_primary", "fsr_all", "type"})
     */
    public function getType()
    {
        return "indicator";
    }

    /**
     * @Groups({"fsr_primary", "fsr_all", "name"})
     */
    public function getName()
    {
        return $this->getValue();
    }

    public function getValueTokens()
    {
        return $this->valueTokens;
    }

    public function setValueTokens($valueTokens)
    {
        $this->valueTokens = $valueTokens;

        return $this;
    }
}
