<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Entity\ViewTemplate;

use App\Traits\Trackable;
use Doctrine\ORM\Mapping as ORM;
use App\Repository\DashboardRepository;
use ApiPlatform\Core\Annotation\ApiResource;

/**
 *  @ApiResource(
 *     attributes={"validation_groups"={"fsr_primary", "fsr_all"}, "fsr_type"="dashboard", "fsr_module"="dashboard", "fsr_singular"="dashboard"},
 *     denormalizationContext={"groups"={"fsr_all", "password"}, "fetch_data"=false},
 *     collectionOperations={
 *          "get" = { "path"="dashboard", "security_post_denormalize" = "is_granted('read.dashboard', object)" },
 *          "post" = { "path"="dashboard", "security_post_denormalize" = "is_granted('create.dashboard', object)" }
 *     },
 *     itemOperations={
 *          "get" = { "path"="dashboard/{uuid}", "security" = "is_granted('read.dashboard', object)" },
 *          "put" = { "path"="dashboard/{uuid}", "security" = "is_granted('update.dashboard', object)" },
 *          "delete" = { "path"="dashboard/{uuid}", "security" = "is_granted('delete.dashboard', object)" }
 *     }
 * )
 * @ORM\Entity(repositoryClass=DashboardRepository::class)
 * @ORM\Table(name="generic_template")
 */
class Dashboard extends GenericTemplate
{
    use Trackable;
}
