<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Entity\ViewTemplate;

use App\Traits\Trackable;
use Doctrine\ORM\Mapping as ORM;
use App\Repository\ReportingRepository;
use ApiPlatform\Core\Annotation\ApiResource;
use App\Entity\ViewTemplate\GenericTemplate;

/**
 *  @ApiResource(
 *     attributes={"validation_groups"={"fsr_primary", "fsr_all"}, "fsr_type"="reporting", "fsr_module"="reporting", "fsr_singular"="reporting"},
 *     denormalizationContext={"groups"={"fsr_all", "password"}, "fetch_data"=false},
 *     collectionOperations={
 *          "get" = { "path"="reporting", "security_post_denormalize" = "is_granted('read.reporting', object)" },
 *          "post" = { "path"="reporting", "security_post_denormalize" = "is_granted('create.reporting', object)" }
 *     },
 *     itemOperations={
 *          "get" = { "path"="reporting/{uuid}", "security" = "is_granted('read.reporting', object)" },
 *          "put" = { "path"="reporting/{uuid}", "security" = "is_granted('update.reporting', object)" },
 *          "delete" = { "path"="reporting/{uuid}", "security" = "is_granted('delete.reporting', object)" }
 *     }
 * )
 * @ORM\Table(name="generic_template")
 * @ORM\Entity(repositoryClass=ReportingRepository::class)
 */
class Reporting extends GenericTemplate
{
    use Trackable;
}
