<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\EventSubscriber;

use App\Service\UtilityService;
use App\Constants\CacheConstants;
use App\Entity\Actors\Actor;
use Doctrine\ORM\Event\LifecycleEventArgs;
use App\Entity\Custom\Appliance;
use App\Entity\Custom\Person;
use Symfony\Contracts\Cache\TagAwareCacheInterface;

class ActorCacheListener
{

    public function __construct(protected UtilityService $utilityService, protected TagAwareCacheInterface $cache)
    {
    }

    private function invalidateCache($args) {
        $entity = $args->getObject()::class;
        if (in_array($entity, [Actor::class, Appliance::class, Person::class])) {
            $this->cache->invalidateTags([CacheConstants::USER_PERMISSIONS, CacheConstants::ACCESSIBLE_PARENT_TEAMS, CacheConstants::ACCESSIBLE_CHILD_TEAMS]);
            $cmd = sprintf('sudo -u nginx php /opt/cyops-api/bin/console app:util %s %s %s',CacheConstants::USER_PERMISSIONS, CacheConstants::ACCESSIBLE_PARENT_TEAMS, CacheConstants::ACCESSIBLE_CHILD_TEAMS);
            $this->utilityService->broadcastToHA($cmd);
        }
    }

    public function postUpdate(LifecycleEventArgs $args)
    {
        $this->invalidateCache($args);
    }

    public function postPersist(LifecycleEventArgs $args)
    {
        $this->invalidateCache($args);
    }
}
