<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\EventSubscriber;

use App\Entity\Core\Picklist;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Contracts\Cache\TagAwareCacheInterface;

class PicklistListener
{
    private $entityManager;
    private $cache;

    public function __construct(
        EntityManagerInterface $entityManager,
        TagAwareCacheInterface $cache
    ) {
        $this->entityManager = $entityManager;
        $this->cache = $cache;
    }

    private function clearPicklistNameCache($picklist)
    {
        if (!is_null($picklist->getListName())) {
            $picklistName = $picklist->getListName()->getName();
            $this->cache->invalidateTags([$picklistName]);
        }
    }

    public function postUpdate(Picklist $picklist)
    {
        $this->clearPicklistNameCache($picklist);
    }

    public function postPersist(Picklist $picklist)
    {
        $this->clearPicklistNameCache($picklist);
    }

    public function postRemove(Picklist $picklist)
    {
        $this->clearPicklistNameCache($picklist);
    }
}
