<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\EventSubscriber;

use App\Constants\CacheConstants;
use App\Entity\Authorization\Team;
use App\Service\UtilityService;
use Symfony\Contracts\Cache\TagAwareCacheInterface;

class TeamListener
{
    protected $cache;
    protected $utilityService;

    public function __construct(UtilityService $utilityService, TagAwareCacheInterface $cache)
    {
        $this->utilityService = $utilityService;
        $this->cache = $cache;
    }

    private function invalidateCache()
    {
        $this->cache->invalidateTags([CacheConstants::ACCESSIBLE_PARENT_TEAMS]);
        $this->cache->invalidateTags([CacheConstants::ACCESSIBLE_CHILD_TEAMS]);
        $cmd = sprintf('sudo -u nginx php /opt/cyops-api/bin/console app:util %s %s', CacheConstants::ACCESSIBLE_PARENT_TEAMS, CacheConstants::ACCESSIBLE_CHILD_TEAMS);
        $this->utilityService->broadcastToHA($cmd);
    }

    public function postUpdate(Team $team)
    {
        $this->invalidateCache();
    }

    public function postPersist(Team $team)
    {
        $this->invalidateCache();
    }

    public function postRemove(Team $team)
    {
        $this->invalidateCache();
    }
}
