<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\EventSubscriber;

use App\Entity\ThreatIntel\ThreatIntelBase;
use App\Service\TokenHelper;
use Doctrine\ORM\Event\PreUpdateEventArgs;
use Exception;

class ThreatIntelListener
{
  private $tokenHelper;

  public function __construct(TokenHelper $tokenHelper)
  {
    $this->tokenHelper = $tokenHelper;
  }

  public function prePersist(ThreatIntelBase $feed)
  {
    try {
      $feed->setValueTokens($this->tokenHelper->extractThreatFeedTokens($feed->getValue()));
    } catch (Exception $e){
      // no field called 'value'. ignore
    } 
  }

  public function preUpdate(ThreatIntelBase $feed, PreUpdateEventArgs $event){
    if ($event->hasChangedField('value')){
      try {
        $feed->setValueTokens($this->tokenHelper->extractThreatFeedTokens($feed->getValue()));
      } catch (Exception $e){
        // no field called 'value'. ignore
      }
    }
  }
}
