<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */
namespace App\Filter;

use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpKernel\Exception\HttpException;


abstract class AbstractFilterQueryBuilder
{
    const UNSUPPORTED_OPERATOR_ERROR_MESSAGE = 'Unsupported operator "%s" specified.';

    /**
     * @param string $operator
     */
    protected function handleUnsupportedOperator($operator)
    {
        $errormsg = (sprintf(self::UNSUPPORTED_OPERATOR_ERROR_MESSAGE, $operator));
        throw new HttpException(Response::HTTP_BAD_REQUEST, $errormsg);
    }
}
