<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations\DefaultMigrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20200320114110 extends AbstractMigration
{
    public function getDescription() : string
    {
        return 'Insert Self Entry for Tenant and Agent';
    }

    public function up(Schema $schema) : void
    {
        $this->addSql("update workflows  set createdate='2018-11-14 07:41:43', modifydate='2018-11-14 07:41:43' where createdate is null;");
        $this->addSql("update workflows set debug=false where debug is null;");
        $fetchSelfTenantResults = $this->connection->fetchAllAssociative("SELECT tenantid FROM tenants WHERE role = 'self'");
        if (!count($fetchSelfTenantResults)) {
            $this->addSql("INSERT INTO TENANTS (id, uuid, name, tenantid, role, description, isDedicated, allowremotemmdmodification) VALUES ('1', 'b3a700f7-00be-4ef9-90c6-3c8fe6e1be63', 'Self', '745d976a-6ae8-4837-a364-64c251ef9e27', 'self', 'sample', true, true)");

            $fetchSOCTeam = $this->connection->fetchAllAssociative("select * from teams where uuid='6e569c09-3bd4-40f1-98b0-cc994464c3c5'");
            if (count($fetchSOCTeam)) {
                $this->addSql("INSERT INTO TENANT_TEAM (tenant_uuid, team_uuid) VALUES ('b3a700f7-00be-4ef9-90c6-3c8fe6e1be63', '6e569c09-3bd4-40f1-98b0-cc994464c3c5')");
            }

            $checkTenantSeq = $this->connection->fetchAllAssociative("select increment from information_schema.sequences where sequence_name='tenants_id_seq';");
            if (count($checkTenantSeq)) {
                $this->addSql("SELECT setval('tenants_id_seq', 2, FALSE);");
            }
        } else {
            $fetchSelfTenantUuid = $fetchSelfTenantResults[0]['tenantid'];
        }
        $fetchSelfAgentResults = $this->connection->fetchAllAssociative("SELECT uuid FROM agents WHERE role = 'self'");
        if (!count($fetchSelfAgentResults)) {
            $selfAgentUuid = $fetchSelfTenantUuid ?? '745d976a-6ae8-4837-a364-64c251ef9e27';
            $sql = "INSERT INTO AGENTS (id, uuid, name, agentid, active, role, description, ssl, isLocal, allowremoteconnectoroperation, auth_type) VALUES ('1', '973c17df-bb4b-41e5-b59c-a408666fdf27', 'Self', '" . $selfAgentUuid . "' , true, 'self', 'sample', true, true, true, '0ec67016-990f-4117-a599-7b12a259d3d3')";
            
            $this->addSql($sql);

            $this->addSql("INSERT INTO TENANT_AGENT (agent_uuid, tenant_uuid) VALUES ('973c17df-bb4b-41e5-b59c-a408666fdf27', 'b3a700f7-00be-4ef9-90c6-3c8fe6e1be63')");
            $fetchSOCTeam = $this->connection->fetchAllAssociative("select * from teams where uuid='6e569c09-3bd4-40f1-98b0-cc994464c3c5'");
            if (count($fetchSOCTeam)) {
                $this->addSql("INSERT INTO AGENT_TEAM (agent_uuid, team_uuid) VALUES ('973c17df-bb4b-41e5-b59c-a408666fdf27', '6e569c09-3bd4-40f1-98b0-cc994464c3c5')");
            }

            $this->addSql("SELECT setval('agents_id_seq', 2, FALSE);");
        }

    }

    public function down(Schema $schema) : void
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
