<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations\DefaultMigrations;

use App\Entity\Core\Proxy;
use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;


/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20220923080918 extends AbstractMigration implements ContainerAwareInterface
{
    const PROXY_UUID = '';
    public function getDescription(): string
    {
        return '';
    }
    /** @var ContainerInterface */
    private $container;

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }


    public function up(Schema $schema): void
    {

        /** @var ResourceInterface $proxyResource */
        $proxyResource = Proxy::class;
        $managerRegistry = $this->container->get('doctrine');
        $proxyManager = $managerRegistry->getManagerForClass($proxyResource);
        $entityRepository = $proxyManager->getRepository(Proxy::class);
        $proxyRecord = $entityRepository->findOneBy(["uuid" => 'c90e8c1b-cu11-as33-3sk-717199a2e182']);
        if ($proxyRecord && is_string($proxyRecord->getProxies()) && !is_null(json_decode($proxyRecord->getProxies(), true))) {
            $proxyJsonRecord = json_decode($proxyRecord->getProxies(), true);
            if (is_string($proxyJsonRecord)) {
                $proxyRecord->setProxies($proxyJsonRecord);
                $proxyManager->persist($proxyRecord);
                $proxyManager->flush();
            }
        }
        $fetchTimResults = $this->connection->fetchAllAssociative("select uuid from staging_model_metadatas where type ='threat_intel_feeds'");
        if (!empty($fetchTimResults)) {
            $this->addSql("update staging_model_metadatas set trackable=true where type='threat_intel_feeds'");
            $this->addSql("alter table threat_intel_feeds add column if not exists modifydate timestamp(6) without time zone DEFAULT now();");
            $this->addSql("alter table threat_intel_feeds add column if not exists createdate timestamp(6) without time zone DEFAULT now();");
        }
    }

    public function down(Schema $schema): void
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
