<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20210205054044 extends AbstractMigration
{
    public function getDescription(): string
    {
        return '6.4.4 Smart Migrations.';
    }

    public function up(Schema $schema): void
    {
        // Safe Migration. Previous Version20201110140712
        $fetchTenantResults = $this->connection->fetchAllAssociative("select uuid from staging_model_metadatas where type='tenants';");
        if (count($fetchTenantResults)) {
            $tenantUuid = $fetchTenantResults[0]['uuid'];
            $this->addSql("update attribute_metadatas set descriptions = '{\"singular\": \"Remote Module Management\"}' where sattrib='" . $tenantUuid . "' and name='allowRemoteMMDModification';");
        }

        // Previous Version20201028110341. Adding Safe Checks.
        $fetchTeams = $this->connection->fetchAllAssociative("select uuid from teams");
        $fetchSelfAgent = $this->connection->fetchAllAssociative("select uuid from agents where role='self'");
        if (count($fetchTeams) && count($fetchSelfAgent)) {
            $fetchSelfAgentTeam = $this->connection->fetchAllAssociative("select count(*) from AGENT_TEAM where agent_uuid='" . $fetchSelfAgent[0]['uuid'] . "'");
            if (!count($fetchSelfAgentTeam)) {
                foreach ($fetchTeams as $team) {
                    $this->addSql("INSERT INTO AGENT_TEAM (agent_uuid, team_uuid) VALUES ('" . $fetchSelfAgent[0]['uuid'] . "', '$team[uuid]') on CONFLICT do nothing");
                }
            }
        }

        // Previous Version Version20201021045220. Adding Safe Checks.
        $validateColumnExists =  $this->connection->fetchAllAssociative("SELECT column_name FROM information_schema.columns WHERE table_name='agents' and column_name='allowremoteconnectoroperation';");
        if (!count($validateColumnExists)) {
            $fetchAgentResults = $this->connection->fetchAllAssociative("select uuid from staging_model_metadatas where type='agents';");
            if (count($fetchAgentResults)) {
                $agentUuid = $fetchAgentResults[0]['uuid'];
                $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, htmlescape, orphanremoval, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, readable, writeable, identifier, \"unique\", displayname, descriptions) VALUES ('e4ca3205-1de7-4445-af3f-040262bc5f18', '" . $agentUuid . "', 'boolean', 'allowRemoteConnectorOperation', 0, 22, 'checkbox', '[]', true, true, true, false, false, false, false, false, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', '[]', '1', '', 'true', true, true, false, false, '{{ allowRemoteConnectorOperation }}', '{\"singular\":\"Allow Remote Connector Operations\"}');");
                $this->addSql("alter table agents add column if not exists allowremoteconnectoroperation boolean default true;");
            }
        }

        // Previous Verion Version20200929061015. Adding Safe Checks
        $validateColumnExists =  $this->connection->fetchAllAssociative("SELECT column_name FROM information_schema.columns WHERE table_name='routers' and column_name='type';");
        if (!count($validateColumnExists)) {
        
            $fetchPicklistNameResults = $this->connection->fetchAllAssociative("select uuid from picklist_names where name='Secure Message Exchange Type';");
            if (!count($fetchPicklistNameResults)) {
                $this->addSql("INSERT INTO public.picklist_names (uuid, name, system, id) VALUES ('c4c9364d-4239-4441-b95e-08bd7aab5570', 'Secure Message Exchange Type', true, 39);");
                $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('302e7cc7-3a4c-4bbc-ba2c-713f23a366d8', 'Embedded', 0, NULL, NULL, 267, 'c4c9364d-4239-4441-b95e-08bd7aab5570');");
                $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('67d24593-405a-4ac2-b46f-edbc9bf51475', 'External', 1, NULL, NULL, 268, 'c4c9364d-4239-4441-b95e-08bd7aab5570');");
            }

            $fetchResults = $this->connection->fetchAllAssociative("SELECT uuid FROM staging_model_metadatas WHERE type = 'routers'");
            if (count($fetchResults)) {
                $fetchResultUuid = $fetchResults[0]['uuid'];
                $fetchPicklistNameResults = $this->connection->fetchAllAssociative("select uuid from attribute_metadatas where name='type' and sattrib='" . $fetchResultUuid . "';");
                if (!count($fetchPicklistNameResults)) {
                    $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, htmlescape, orphanremoval, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, readable, writeable, identifier, \"unique\", displayname, descriptions) VALUES ('7ea06016-3e67-4d90-916e-aa8e54f7f7b4','" . $fetchResultUuid . "', 'picklists', 'type', 0, 1, 'picklist', '{\"model\":\"picklists\",\"query\":{\"logic\":\"AND\",\"filters\":[{\"field\":\"listName__name\",\"operator\":\"eq\",\"value\":\"Secure Message Exchange Type\"}],\"sort\":[{\"field\":\"orderIndex\",\"direction\":\"ASC\"}]},\"displayConditions\":{\"06a44003-cf9e-4ca2-8404-a08f4afbdd66\":{\"visibility\":\"visible\",\"conditions\":null},\"3395c8e5-4a37-4ec0-adfb-e168c9f3b869\":{\"visibility\":\"visible\",\"conditions\":null}}}', false, true, false, false, false, false, false, false, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', '[]', '/api/3/picklists/67d24593-405a-4ac2-b46f-edbc9bf51475', '', 'false', true, true, false, false, '{{ type }}', '{\"singular\":\"Type\"}');");
                }
            }


            $this->addSql("alter table routers add column type varchar;");
            $this->addSql("update routers set type='67d24593-405a-4ac2-b46f-edbc9bf51475'");
            $this->addSql("update routers set type='302e7cc7-3a4c-4bbc-ba2c-713f23a366d8' where uuid='52c5cee8-5c28-4ed2-a886-ec8bf4dc5993'");
        }
    }

    public function down(Schema $schema): void
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
