<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20210205231427 extends AbstractMigration
{
    public function getDescription(): string
    {
        return 'Communication module migration';
    }

    public function up(Schema $schema): void
    {
        
        $this->addSql("ALTER TABLE public.staging_model_metadatas ADD COLUMN IF NOT EXISTS userownable BOOLEAN NOT NULL DEFAULT FALSE;");
        $this->addSql("ALTER TABLE public.staging_model_metadatas ADD COLUMN IF NOT EXISTS system BOOLEAN NOT NULL DEFAULT FALSE;");
        $this->addSql("ALTER TABLE public.staging_model_metadatas ADD COLUMN IF NOT EXISTS module varchar(500) NULL;");
        $this->addSql("ALTER TABLE attribute_metadatas add column if not exists recommend boolean not null default false;");

        $this->addSql("ALTER TABLE public.model_metadatas ADD COLUMN IF NOT EXISTS userownable BOOLEAN NOT NULL DEFAULT FALSE;");
        $this->addSql("ALTER TABLE public.model_metadatas ADD COLUMN IF NOT EXISTS system BOOLEAN NOT NULL DEFAULT FALSE;");
        $this->addSql("ALTER TABLE public.model_metadatas ADD COLUMN IF NOT EXISTS module varchar(500) NULL;");
        $this->addSql("ALTER TABLE attrib_model_metadata add column if not exists recommend boolean not null default false;");

        $fetchResults = $this->connection->fetchAllAssociative("SELECT uuid FROM picklist_names WHERE name='Choose Report'");
        if (!count($fetchResults)) {
            $this->addSql("INSERT INTO public.picklist_names (uuid, name, system, id) VALUES ('384a7cc4-2089-479e-a5ab-1ab6c90e6c16', 'Choose Report', true, 5519);");
            $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('7b267bcd-b1ad-4514-ba6d-8cf705b3d865', 'War Room Summary', 0, NULL, NULL, 5520, '384a7cc4-2089-479e-a5ab-1ab6c90e6c16');");
            $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('deabd332-b3cf-456e-93d8-6debb0896b78', 'War Room Task Status', 1, NULL, NULL, 5521, '384a7cc4-2089-479e-a5ab-1ab6c90e6c16');");
        }

    }

    public function down(Schema $schema): void
    {
        // this down() migration is auto-generated, please modify it to your needs
        $this->addSql("DELETE FROM public.picklists WHERE listname='384a7cc4-2089-479e-a5ab-1ab6c90e6c16'");
        $this->addSql("DELETE FROM public.picklist_names WHERE uuid='384a7cc4-2089-479e-a5ab-1ab6c90e6c16'");
    }
}
