<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20210211170528 extends AbstractMigration
{
    public function getDescription() : string
    {
        return '';
    }

    public function up(Schema $schema) : void
    {
        $fetchCommentResults = $this->connection->fetchAllAssociative("SELECT uuid FROM staging_model_metadatas WHERE type = 'comments'");
        if(count($fetchCommentResults)) { 
            $commentUuid = $fetchCommentResults[0]['uuid'];
            $isImportant = "INSERT INTO public.attribute_metadatas (uuid, sattrib, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, htmlescape, orphanremoval, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, readable, writeable, identifier, \"unique\", displayname, descriptions) VALUES 
            ('6829ce06-a3a0-4819-a608-076c5fb9e7c5', '" . $commentUuid ."', 'boolean', 'isImportant', 0, 24, 'checkbox', NULL, false, true, true, false, false, false, false, false, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":-1}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, NULL, NULL, true, true, true, false, false, '{{ isImportant }}', '{\"singular\":\"Is Important\"}');";
            $this->addSql($isImportant);

            $peopleUpdated = "INSERT INTO public.attribute_metadatas (uuid, sattrib, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, htmlescape, orphanremoval, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, readable, writeable, identifier, \"unique\", displayname, descriptions) VALUES 
            ('412e4803-8a92-45f7-bac8-51a9b389d787', '" . $commentUuid ."', 'boolean', 'peopleUpdated', 0, 25, 'checkbox', NULL, false, true, true, false, false, false, false, false, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":-1}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, NULL, NULL, true, true, true, false, false, '{{ peopleUpdated }}', '{\"singular\":\"People Updated\"}');";
            $this->addSql($peopleUpdated);


            $replyTo = "INSERT INTO public.attribute_metadatas (uuid, sattrib, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, htmlescape, orphanremoval, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, readable, writeable, identifier, \"unique\", displayname, descriptions) VALUES 
            ('e9385d8d-1351-45ca-901a-a3939f729295', '" . $commentUuid ."', 'comments', 'replyTo', 0, 26, 'lookup', '{\"model\": \"comments\"}', false, true, true, false, false, true, false, false, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, NULL, NULL, true, true, true, false, false, '{{ replyTo }}', '{\"singular\":\"Reply To \"}');";
            $this->addSql($replyTo);

            $replies = "INSERT INTO public.attribute_metadatas (uuid, sattrib, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, htmlescape, orphanremoval, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, readable, writeable, identifier, \"unique\", displayname, descriptions) VALUES 
            ('3ff0f0d0-17e0-40d7-960d-21cc0146851b', '" . $commentUuid ."', 'comments', 'replies', 0, 27, 'oneToMany', '{\"model\": \"comments\"}', false, true, true, false, false, true, false, true, 'replyTo', 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, NULL, NULL, true, true, true, false, false, '{{ replies }}', '{\"singular\":\"Replies \"}');";
            $this->addSql($replies);

            $lastReplyDate = "INSERT INTO public.attribute_metadatas (uuid, sattrib, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, htmlescape, orphanremoval, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, readable, writeable, identifier, \"unique\", displayname, descriptions) VALUES 
            ('3221a698-6cc6-46e8-9506-cb81993864aa', '" . $commentUuid ."', 'integer', 'lastReplyDate', 0, 28, 'datetime', NULL, false, true, true, false, false, false, false, true, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":-1}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, NULL, NULL, true, true, true, false, false, '{{ lastReplyDate }}', '{\"singular\":\"Last Reply Date \"}');";
            $this->addSql($lastReplyDate);


            $commentNotificationsWorkflows = "INSERT INTO workflow_collections (uuid, name, description, visible, id) VALUES ('94126e6b-16a4-46c0-8ebe-228cc013afac', 'Comment Notifications', 'Notify people when they are mentioned in a comment', false, nextval('global_id_seq'))";
            $this->addSql($commentNotificationsWorkflows);

            $this->addSql("update comments set lastReplyDate=createDate");
        }
    }

    public function down(Schema $schema) : void
    {
        $this->addSql("DELETE FROM workflow_collections where uuid='94126e6b-16a4-46c0-8ebe-228cc013afac';");
        $this->addSql("DELETE FROM public.attribute_metadatas WHERE name='isImportant'");
        $this->addSql("DELETE FROM public.attribute_metadatas WHERE name='peopleUpdated'");
        $this->addSql("DELETE FROM public.attribute_metadatas WHERE name='replyTo'");
        $this->addSql("DELETE FROM public.attribute_metadatas WHERE name='replies'");
        $this->addSql("DELETE FROM public.attribute_metadatas WHERE name='lastReplyDate'");
    }
}
