<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20210305164658 extends AbstractMigration
{
    public function getDescription() : string
    {
        return 'Announcemnet module defination and other migrations';
    }

    public function up(Schema $schema) : void
    {

        $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('33b6b889-4c5c-4801-999b-6c446b9568f3', 'On Hold/Blocked', 5, '#de1919', NULL, 2, '21ddbcfd-b4a3-4273-adea-c674fe47d643');");

        $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('321ad354-42ce-42b6-8636-2fa184a7dcd5', 'Isolated', 2, NULL, NULL, 94, '45de7d2e-8ef0-495e-a6e5-07fddfbd4749');");

        $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('959021fc-c19d-4aee-8e51-5395c5029719', 'In progress', 7, '#ffce1f', NULL, 117, '21ddbcfd-b4a3-4273-adea-c674fe47d643');");

        $fetchResults = $this->connection->fetchAllAssociative("SELECT uuid FROM picklist_names WHERE name='AnnoucementType'");
        if (!count($fetchResults)) {
            $this->addSql("INSERT INTO public.picklist_names (uuid, name, system, id) VALUES ('e14df345-8c19-4fbd-8d27-860c765def6f', 'AnnoucementType', true, 44);");
            $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('222b116d-d495-4eb9-b12d-c71cb7b7ba6e', 'Meeting', 0, NULL, NULL, 284, 'e14df345-8c19-4fbd-8d27-860c765def6f');");
            $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('cfbb2798-ec01-4652-b774-fb2c19e35eb5', 'Information', 1, NULL, NULL, 285, 'e14df345-8c19-4fbd-8d27-860c765def6f');");
            $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('9745d253-ac30-4ded-b6ed-3370c16da022', 'Generic', 2, NULL, NULL, 286, 'e14df345-8c19-4fbd-8d27-860c765def6f');");
        }

        $fetchResults = $this->connection->fetchAllAssociative("SELECT uuid FROM picklist_names WHERE name='AnnouncementCriticality'");
        if (!count($fetchResults)) {
            $this->addSql("INSERT INTO public.picklist_names (uuid, name, system, id) VALUES ('520e35ae-c3c2-45f5-bc73-af6b9476cbeb', 'AnnouncementCriticality', true, 45);");
            $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('e8e41070-f135-42f2-892b-7017cbba4024', 'Generic', 0, '#ebb11e', NULL, 287, '520e35ae-c3c2-45f5-bc73-af6b9476cbeb');");
            $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('75979d6f-867a-4422-8531-25c8a5fd81ef', 'Important', 1, '#de2626', NULL, 288, '520e35ae-c3c2-45f5-bc73-af6b9476cbeb');");
        }

        $fetchResults = $this->connection->fetchAllAssociative("SELECT uuid FROM picklist_names WHERE name='TaskTeams'");
        if (!count($fetchResults)) {
            $this->addSql("INSERT INTO public.picklist_names (uuid, name, system, id) VALUES ('30efdc50-1f3d-40d3-909f-e71386dea13e', 'TaskTeams', true, 46);");
            $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('ff7a6c07-4b23-49e7-93a2-22940abe02af', 'Exec Team', 0, NULL, NULL, 279, '30efdc50-1f3d-40d3-909f-e71386dea13e');");
            $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('b46a9545-e3e1-4035-b4a2-e3fc775eeba1', 'Firewall Team', 0, NULL, NULL, 280, '30efdc50-1f3d-40d3-909f-e71386dea13e');");
            $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('ef2f2630-a3fa-4da6-b700-bf0492cb19ac', 'EDR Team', 0, NULL, NULL, 281, '30efdc50-1f3d-40d3-909f-e71386dea13e');");
            $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('3c99ae53-2036-41ef-98df-63080c88b621', 'IT Team', 0, NULL, NULL, 282, '30efdc50-1f3d-40d3-909f-e71386dea13e');");
            $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('52db93a5-6a18-4bf3-80b4-059351119d76', 'SOC Team', 0, NULL, NULL, 283, '30efdc50-1f3d-40d3-909f-e71386dea13e');");
        }
        
        //Atrribute Metadata for tasks module
        $fetchResults = $this->connection->fetchAllAssociative("SELECT uuid FROM staging_model_metadatas WHERE type='tasks'");
        if (count($fetchResults)) {
            $resultUuid = $fetchResults[0]['uuid'];
            $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('5b55fe91-7dae-40fc-ae54-3a3da904f696', '" . $resultUuid . "', '{{ taskTeams }}', '{\"singular\":\"Teams\"}', 'picklists', 'taskTeams', NULL, 1, 'picklist', '{\"model\":\"picklists\",\"query\":{\"logic\":\"AND\",\"filters\":[{\"field\":\"listName__name\",\"operator\":\"eq\",\"value\":\"TaskTeams\"}],\"sort\":[{\"field\":\"orderIndex\",\"direction\":\"ASC\"}]},\"displayConditions\":{\"ff7a6c07-4b23-49e7-93a2-22940abe02af\":{\"visibility\":\"visible\",\"conditions\":null},\"b46a9545-e3e1-4035-b4a2-e3fc775eeba1\":{\"visibility\":\"visible\",\"conditions\":null},\"ef2f2630-a3fa-4da6-b700-bf0492cb19ac\":{\"visibility\":\"visible\",\"conditions\":null},\"3c99ae53-2036-41ef-98df-63080c88b621\":{\"visibility\":\"visible\",\"conditions\":null},\"52db93a5-6a18-4bf3-80b4-059351119d76\":{\"visibility\":\"visible\",\"conditions\":null}}}', false, false, false, false, false, false, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, NULL, NULL, 'true', false, false, true, true, false, false, false);");
        }

        $fetchResults = $this->connection->fetchAllAssociative("SELECT uuid FROM staging_model_metadatas WHERE type='announcements'");
        if (!count($fetchResults)) {
            $this->addSql("INSERT INTO public.modules (uuid, createuser, modifyuser, type, name, system, icon, description, createdate, modifydate) VALUES ('46e703bf-841f-465a-8fc4-8b7f9b7e078a', NULL, NULL, 'announcements', 'Announcements', false, NULL, 'Allows interactions with the Announcements Module', NULL, NULL);");

            $this->addSql("INSERT INTO public.staging_model_metadatas (uuid, displayname, descriptions, type, parenttype, tablename, ownable, userownable, trackable, taggable, peerreplicable, defaultsort, uniqueconstraint, indexable, writable, system, module) VALUES ('5d49aba4-41b6-4f91-8a56-d370bd19bf3f', '{{title}}', '{\"singular\":\"Announcement\",\"plural\":\"Announcements\"}', 'announcements', NULL, 'announcements', true, false, true, true, false, '[]', '[]', true, true, false, 'announcements');");

            $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('ee97fd45-f4b2-4b71-80a2-2846195f795e', '5d49aba4-41b6-4f91-8a56-d370bd19bf3f', '{{ warrooms }}', '{\"singular\":\"War Rooms\"}', 'warrooms', 'warrooms', NULL, 2, 'manyToMany', '{\"model\":\"warrooms\"}', false, true, false, false, false, true, 'announcements', 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761,\"_enableRange\":false}', '[]', NULL, NULL, NULL, 'true', false, false, true, true, false, false, false);");
            
            $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('b2c4fd20-eb15-46d1-9335-71ea16af0f79', '5d49aba4-41b6-4f91-8a56-d370bd19bf3f', '{{ announcementCriticality }}', '{\"singular\":\"Criticality\"}', 'picklists', 'announcementCriticality', NULL, 3, 'picklist', '{\"model\":\"picklists\",\"query\":{\"logic\":\"AND\",\"filters\":[{\"field\":\"listName__name\",\"operator\":\"eq\",\"value\":
            \"AnnouncementCriticality\"}],\"sort\":[{\"field\":\"orderIndex\",\"direction\":\"ASC\"}]},\"displayConditions\":{\"e8e41070-f135-42f2-892b-7017cbba4024\":{\"visibility\":\"visible\",\"conditions\":null},\"75979d6f-867a-4422-8531-25c8a5fd81ef\":{\"visibility\":\"visible\",\"conditions\":null}}}', false, true, false, false, true, false, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761,\"_enableRange\":false}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, '/api/3/picklists/e8e41070-f135-42f2-892b-7017cbba4024', NULL, 'true', false, false, true, true, false, false, false);");

            $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('dbf97c7c-4a6a-4eda-92d8-ea4044358520', '5d49aba4-41b6-4f91-8a56-d370bd19bf3f', '{{ title }}', '{\"singular\":\"Title\"}', 'string', 'title', NULL, 4, 'text', NULL, false, true, false, false, true, false, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, '', NULL, 'true', false, false, true, true, false, false, false);");

            $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('88d1afaa-b2fe-411f-8753-bc5f5d8587b8', '5d49aba4-41b6-4f91-8a56-d370bd19bf3f', '{{ description }}', '{\"singular\":\"Description\"}', 'string', 'description', NULL, 5, 'html', NULL, true, true, false, false, false, false, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, '', NULL, 'true', false, false, true, true, false, false, false);");

            $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('072f2fbc-f186-4cf3-a13e-49decf6bcb34', '5d49aba4-41b6-4f91-8a56-d370bd19bf3f', '{{ notifyOnEmail }}', '{\"singular\":\"Notify Responders On Email\"}', 'boolean', 'notifyOnEmail', NULL, 1, 'checkbox', NULL, true, true, false, false, false, false, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761,\"_enableRange\":false}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, NULL, NULL, 'true', false, false, true, true, false, false, false);");

            $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('7f3eb551-bfab-4d1c-980b-42f19ac77e1e', '5d49aba4-41b6-4f91-8a56-d370bd19bf3f', '{{ announcementType }}', '{\"singular\":\"Announcement Type\"}', 'picklists', 'announcementType', NULL, 6, 'picklist', '{\"model\":\"picklists\",\"query\":{\"logic\":\"AND\",\"filters\":[{\"field\":\"listName__name\",\"operator\":\"eq\",\"value\":\"AnnoucementType\"}],\"sort\":[{\"field\":\"orderIndex\",\"direction\":\"ASC\"}]},\"displayConditions\":{\"222b116d-d495-4eb9-b12d-c71cb7b7ba6e\":{\"visibility\":\"visible\",\"conditions\":null},\"cfbb2798-ec01-4652-b774-fb2c19e35eb5\":{\"visibility\":\"visible\",\"conditions\":null},\"9745d253-ac30-4ded-b6ed-3370c16da022\":{\"visibility\":\"visible\",\"conditions\":null}}}', false, true, false, false, true, false, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761,\"_enableRange\":false}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, '/api/3/picklists/cfbb2798-ec01-4652-b774-fb2c19e35eb5', NULL, 'true', false, false, true, true, false, false, false);");

            $this->addSql("INSERT INTO cyops.system_view_template (uuid, type, config) VALUES ('modules-announcements-form', 'form', '{\"rows\":[{\"columns\":[{\"widgets\":[{\"type\":\"formGroup\",\"config\":{\"wid\":\"39dca99d-b9e2-47b8-aef5-d6929c02c264\",\"rows\":[{\"columns\":[{\"fields\":[{\"name\":\"announcementType\",\"highlightMode\":true,\"linky\":true,\"readOnly\":false},{\"name\":\"announcementCriticality\",\"highlightMode\":true,\"linky\":true,\"readOnly\":false},{\"name\":\"title\",\"highlightMode\":true,\"linky\":true,\"readOnly\":false},{\"name\":\"description\",\"highlightMode\":true,\"linky\":true,\"readOnly\":false},{\"name\":\"notifyOnEmail\",\"highlightMode\":true,\"linky\":true,\"readOnly\":false}]}]}]}}],\"style\":\"col-lg-12\"}],\"wid\":\"e37f4901-081a-4254-97fd-51f9a9bb2378\",\"_collapsed\":false}],\"wid\":\"5c51ea3b-2f88-49a0-bd99-c645f75bca1e\",\"style\":\"col-lg-6 col-lg-offset-3 col-md-8 col-md-offset-2 col-sm-10 col-sm-offset-1\"}');");

            $this->addSql("INSERT INTO cyops.system_view_template (uuid, type, config) VALUES ('modules-announcements-list', 'rows', '{\"rows\":[{\"columns\":[{\"widgets\":[{\"type\":\"grid\",\"config\":{\"wid\":\"cd9a8607-d9f5-4b58-8517-f99db949ad19\",\"module\":\"announcements\",\"columns\":[\"id\",\"announcementType\",\"title\",\"createDate\",\"createUser\"],\"expandableCol\":[],\"relationshipField\":[],\"checkboxStatus\":false,\"actionButtons\":[],\"query\":{\"sort\":[],\"limit\":30,\"logic\":\"AND\",\"filters\":[]}}}],\"style\":\"col-lg-12\"}],\"wid\":\"51b4cf21-bc20-44c0-b805-8a3d04affa7f\",\"_collapsed\":false}],\"wid\":\"92f82767-31f0-479d-9a1a-1db72a27d6bf\"}');");

            $this->addSql("INSERT INTO cyops.system_view_template (uuid, type, config) VALUES ('modules-announcements-detail', 'rows', '{\"rows\":[{\"columns\":[{\"widgets\":[{\"type\":\"primaryDetail\",\"config\":{\"wid\":\"3e7048c4-63f5-44bf-89bb-d2be9c59a0cf\",\"idField\":\"id\",\"picklistFieldReadOnly\":true,\"titleFieldReadOnly\":false,\"titleFieldLinky\":false,\"featuredRelationship\":{\"field\":null,\"preText\":\"Under Investigation In\",\"query\":null,\"statusField\":null,\"sort\":[]},\"picklistField\":\"announcementType\",\"titleField\":\"title\"}}],\"style\":\"col-lg-12\"}],\"wid\":\"cd1bee28-49a0-4c96-9fed-f71199d077ca\",\"_collapsed\":false},{\"columns\":[{\"widgets\":[{\"type\":\"editableFormGroup\",\"config\":{\"wid\":\"f643fede-968e-4058-a561-9a542ca5bf9a\",\"rows\":[{\"columns\":[{\"fields\":[{\"name\":\"title\",\"highlightMode\":true,\"linky\":true,\"readOnly\":false},{\"name\":\"description\",\"highlightMode\":true,\"linky\":true,\"readOnly\":false},{\"name\":\"notifyOnEmail\",\"highlightMode\":true,\"linky\":true,\"readOnly\":false}]}]}]}}],\"style\":\"col-lg-12\"}],\"wid\":\"28d2567b-bb12-4364-b98f-3eb85c7fe85a\",\"_collapsed\":false},{\"columns\":[{\"widgets\":[{\"type\":\"tabs\",\"config\":{\"tabs\":[{\"title\":\"Correlations\",\"widget\":{\"type\":\"relationship.subtab\",\"config\":{\"excludes\":[\"notes\",\"comments\",\"userOwners\",\"attachments\"],\"wid\":\"eb1bfffe-d356-48f2-877f-12e8ae672ccd\"}},\"show\":true,\"icon\":\"fa fa-exchange\"}],\"wid\":\"849400b1-07e3-49e8-8169-86b82e49c2c7\"}}],\"style\":\"col-lg-12\"}],\"wid\":\"c25c5683-d6ea-45b2-ac0f-2ce700bfa2d5\",\"_collapsed\":false}],\"wid\":\"349ed4a7-ccb1-4623-936d-552d98186642\",\"actionButtons\":[]}');");

        }

        $fetchResults = $this->connection->fetchAllAssociative("SELECT uuid FROM actors WHERE uuid='3451141c-bac6-467c-8d72-85e0fab569ce'");
        if (count($fetchResults)) {
            $actorUuid = '3451141c-bac6-467c-8d72-85e0fab569ce';
        } else {
            $fetchResults = $this->connection->fetchAllAssociative("select uuid from actors where firstname is not null order by id limit 1;");
            $actorUuid = $fetchResults[0]['uuid'];
        }
        //Reports
        $this->addSql("INSERT INTO public.generic_template (uuid, createuser, modifyuser, displayname, type, templatetype, parenttemplateid, config, filterarray, updatedate, createdate, modifydate, generictype) VALUES ('60f0c032-90e8-4026-b430-176efd5560b7', '$actorUuid', '$actorUuid', 'War Room Summary Report', 'rows', 'reporting', NULL, '{\"rows\":[{\"columns\":[{\"widgets\":[{\"type\":\"sectionHeader\",\"config\":{\"wid\":\"7dde165c-b423-4d31-a018-cf0399813c00\",\"sectionText\":\"<p style=\\\"text-align: center;\\\">&nbsp;<\/p>\\n<p style=\\\"text-align: center; background: #4e94d0; padding-top: 5px;\\\"><span style=\\\"font-size: 25pt;\\\"><strong><span style=\\\"color: #efefee;\\\">War Room Summary Report<\/span>&nbsp;<\/strong><\/span><\/p>\\n<p style=\\\"background: #2a5173; padding-top: 5px; padding-right: 5px; padding-bottom: 5px; text-align: center;\\\"><span style=\\\"font-size: 12pt; color: #efefee;\\\">Generated On {{todayDate}}<\/span><\/p>\",\"query\":{\"filters\":[],\"sort\":[],\"limit\":10},\"editorType\":\"html\"}}],\"style\":\"col-lg-12\"}],\"wid\":\"519727ca-5677-4a5d-954b-8c2c0de8aee5\",\"container\":false,\"_collapsed\":false},{\"columns\":[{\"widgets\":[{\"type\":\"sectionHeader\",\"config\":{\"wid\":\"c96ab5d9-40f0-4563-bd8b-f4443626233c\",\"query\":{\"filters\":[],\"sort\":[],\"limit\":10},\"editorType\":\"html\",\"sectionText\":\"<h3><strong><span class=\\\"cs-richtext-field\\\" title=\\\"Warrooms ID {{warRoomID}} - Title\\\">{{title}}<\/span><\/strong><\/h3>\",\"fieldType\":\"record fields\",\"resource\":\"warrooms\",\"resourceId\":\"{{warRoomID}}\"}},{\"type\":\"readonlyFormGroup\",\"config\":{\"wid\":\"2927532b-ddf4-4188-bc6e-ddbd8ed9e4f2\",\"gridColumns\":[],\"displayType\":\"card-view\",\"widgetAlwaysDisplay\":true,\"query\":{\"sort\":[],\"limit\":10,\"logic\":\"AND\",\"filters\":[{\"field\":\"id\",\"operator\":\"eq\",\"_operator\":\"eq\",\"value\":\"{{warRoomID}}\",\"type\":\"primitive\"}]},\"recordTitle\":{\"type\":\"sectionHeader\",\"wid\":\"f0712be2-19ce-4b71-a9ac-e1e6c2ea8af6\",\"clone\":false,\"remove\":false},\"relatedTemplate\":{\"type\":\"rows\",\"rows\":[],\"wid\":\"087a984b-3489-4e23-98df-948471bac09e\"},\"rows\":[{\"columns\":[{\"fields\":[{\"name\":\"summary\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-12\"}]},{\"columns\":[{\"fields\":[{\"name\":\"currentStatus\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-6\"},{\"fields\":[{\"name\":\"nextSteps\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-6\"}]}],\"resource\":\"warrooms\"}},{\"type\":\"lineItem\",\"config\":{\"query\":{\"sort\":[],\"limit\":5,\"logic\":\"AND\",\"filters\":[{\"field\":\"warrooms.id\",\"operator\":\"eq\",\"_operator\":\"eq\",\"value\":\"{{warRoomID}}\",\"type\":\"primitive\"}]},\"mapping\":{\"assignedToPerson\":\"\"},\"columns\":[\"content\",\"createUser\",\"createDate\"],\"wid\":\"da31f18f-3d77-4a73-96cf-2016c1b4d3ff\",\"title\":\"Latest 5 Comments\",\"module\":\"comments\"}}],\"style\":\"col-lg-12\"}],\"wid\":\"f207f02d-85f5-4187-9d7e-1e0ea8741217\",\"container\":true,\"_collapsed\":false},{\"columns\":[{\"widgets\":[{\"type\":\"sectionHeader\",\"config\":{\"wid\":\"2a73fc24-3a99-46d2-bd91-9f4ade043c87\",\"sectionText\":\"<h5 style=\\\"background: #404142; padding: 5px; text-align: left;\\\"><span style=\\\"font-size: 12pt; color: #ffffff;\\\"><strong>RELATED RECORDS<\/strong><\/span><\/h5>\",\"query\":{\"filters\":[],\"sort\":[],\"limit\":10},\"editorType\":\"html\"}},{\"type\":\"rows\",\"config\":{\"wid\":\"30aa756c-a024-41f3-8c3d-b4646011bd42\",\"rows\":[{\"columns\":[{\"widgets\":[{\"type\":\"performanceMetrics\",\"config\":{\"wid\":\"aa5fac42-0f72-49f9-b405-eafb2c45419c\",\"includeFailedPlaybooks\":true,\"excludeConfigActions\":true,\"days\":30,\"showPercentageChanges\":false,\"metricsType\":\"totalCount\",\"title\":\"Related Incidents\",\"resource\":\"incidents\",\"query\":{\"sort\":[],\"limit\":30,\"logic\":\"AND\",\"filters\":[{\"field\":\"warrooms.id\",\"operator\":\"eq\",\"_operator\":\"eq\",\"value\":\"{{warRoomID}}\",\"type\":\"primitive\"}]},\"timeRange\":\"createDate\",\"grouping\":{\"primary\":[],\"secondary\":[]},\"showSavings\":\"dollar\"}}],\"style\":\"col-lg-3\"},{\"widgets\":[{\"type\":\"performanceMetrics\",\"config\":{\"wid\":\"3908fbed-7b9f-42d2-81da-c71d2cc87177\",\"includeFailedPlaybooks\":true,\"excludeConfigActions\":true,\"days\":30,\"showPercentageChanges\":false,\"metricsType\":\"totalCount\",\"title\":\"Related Alerts\",\"resource\":\"alerts\",\"query\":{\"sort\":[],\"limit\":30,\"logic\":\"AND\",\"filters\":[{\"field\":\"warrooms.id\",\"operator\":\"eq\",\"_operator\":\"eq\",\"value\":\"{{warRoomID}}\",\"type\":\"primitive\"}]},\"timeRange\":\"createDate\",\"grouping\":{\"primary\":[],\"secondary\":[]},\"showSavings\":\"dollar\"}}],\"style\":\"col-lg-3\"},{\"widgets\":[{\"type\":\"performanceMetrics\",\"config\":{\"wid\":\"b2545b77-0c9c-4ae3-848f-d62cad83e46f\",\"includeFailedPlaybooks\":true,\"excludeConfigActions\":true,\"days\":30,\"showPercentageChanges\":false,\"metricsType\":\"totalCount\",\"title\":\"Related Indicators\",\"resource\":\"indicators\",\"query\":{\"sort\":[],\"limit\":30,\"logic\":\"AND\",\"filters\":[{\"field\":\"warrooms.id\",\"operator\":\"eq\",\"_operator\":\"eq\",\"value\":\"{{warRoomID}}\",\"type\":\"primitive\"}]},\"timeRange\":\"createDate\",\"grouping\":{\"primary\":[],\"secondary\":[]},\"showSavings\":\"dollar\"}}],\"style\":\"col-lg-3\"},{\"widgets\":[{\"type\":\"performanceMetrics\",\"config\":{\"wid\":\"d1cbe70b-d276-49ee-a4d9-be8c78ce7b59\",\"includeFailedPlaybooks\":true,\"excludeConfigActions\":true,\"days\":30,\"showPercentageChanges\":false,\"metricsType\":\"totalCount\",\"title\":\"Related Assets\",\"resource\":\"assets\",\"query\":{\"sort\":[],\"limit\":30,\"logic\":\"AND\",\"filters\":[{\"field\":\"warrooms.id\",\"operator\":\"eq\",\"_operator\":\"eq\",\"value\":\"{{warRoomID}}\",\"type\":\"primitive\"}]},\"timeRange\":\"createDate\",\"grouping\":{\"primary\":[],\"secondary\":[]},\"showSavings\":\"dollar\"}}],\"style\":\"col-lg-3\"}],\"wid\":\"a4ca0f75-fa90-4a47-a897-8bd0626a97b7\",\"_collapsed\":false}]}}],\"style\":\"col-lg-12\"}],\"wid\":\"de2bf7f4-61f6-4f69-83d3-d7b7e802e6e0\",\"container\":true,\"_collapsed\":false},{\"columns\":[{\"widgets\":[{\"type\":\"sectionHeader\",\"config\":{\"wid\":\"b84b7a55-19a9-43fe-bd1e-228d70d0f769\",\"sectionText\":\"<h6 style=\\\"background: #404142; padding: 5px; text-align: left;\\\"><span style=\\\"font-size: 10pt; color: #ffffff;\\\"><strong>Related Alerts<\/strong><\/span><\/h6>\"}},{\"type\":\"readonlyFormGroup\",\"config\":{\"wid\":\"061cb397-6103-4c9d-b493-85f080f977ad\",\"query\":{\"sort\":[],\"limit\":10,\"logic\":\"AND\",\"filters\":[{\"field\":\"warrooms.id\",\"operator\":\"eq\",\"_operator\":\"eq\",\"value\":\"{{warRoomID}}\",\"type\":\"primitive\"}]},\"rows\":[{\"columns\":[{\"fields\":[{\"name\":\"name\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-12\"}]},{\"columns\":[{\"fields\":[{\"name\":\"status\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-3\"},{\"fields\":[{\"name\":\"severity\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-3\"},{\"fields\":[{\"name\":\"type\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-3\"},{\"fields\":[{\"name\":\"assignedTo\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-3\"}]}],\"resource\":\"alerts\",\"style\":\"display-inline-block\",\"displayType\":\"card-view\",\"gridColumns\":[],\"widgetAlwaysDisplay\":true,\"recordTitle\":{\"type\":\"sectionHeader\",\"wid\":\"de9d36f0-8b33-4daa-8ac2-a01fbd8ee0ea\",\"clone\":false,\"remove\":false},\"relatedTemplate\":{\"type\":\"rows\",\"rows\":[],\"wid\":\"d8660060-5577-4481-85b6-df833c936d9c\"}}}],\"style\":\"col-lg-12\"}],\"wid\":\"0d1ace32-cf1e-402b-83d5-ba863105d1b7\",\"container\":true,\"_collapsed\":false},{\"columns\":[{\"widgets\":[{\"type\":\"sectionHeader\",\"config\":{\"wid\":\"89d92097-f49c-4eeb-85c5-6583fa80ec19\",\"sectionText\":\"<h6 style=\\\"background: #404142; padding: 5px; text-align: left;\\\"><span style=\\\"font-size: 10pt; color: #ffffff;\\\"><strong>Related Incidents<\/strong><\/span><\/h6>\",\"query\":{\"filters\":[],\"sort\":[],\"limit\":10},\"editorType\":\"html\"}},{\"type\":\"readonlyFormGroup\",\"config\":{\"wid\":\"fbaead0a-a0c2-493c-9239-819c8e762b22\",\"query\":{\"sort\":[],\"limit\":10,\"logic\":\"AND\",\"filters\":[{\"field\":\"warrooms.id\",\"operator\":\"eq\",\"_operator\":\"eq\",\"value\":\"{{warRoomID}}\",\"type\":\"primitive\"}]},\"rows\":[{\"columns\":[{\"fields\":[{\"name\":\"name\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-12\"}]},{\"columns\":[{\"fields\":[{\"name\":\"status\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-3\"},{\"fields\":[{\"name\":\"severity\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-3\"},{\"fields\":[{\"name\":\"phase\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-3\"},{\"fields\":[{\"name\":\"incidentLead\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-3\"}]}],\"resource\":\"incidents\",\"style\":\"display-inline-block\",\"displayType\":\"card-view\",\"gridColumns\":[],\"widgetAlwaysDisplay\":true,\"recordTitle\":{\"type\":\"sectionHeader\",\"wid\":\"dccc66ad-fa64-48b3-860f-44dd0a931eeb\",\"clone\":false,\"remove\":false},\"relatedTemplate\":{\"type\":\"rows\",\"rows\":[],\"wid\":\"e7ceabcd-f989-45f4-b2d1-04a06d6ac763\"}}}],\"style\":\"col-lg-12\"}],\"wid\":\"10ecd1f0-6ec6-44a1-8786-348def8988cf\",\"container\":true,\"_collapsed\":false},{\"columns\":[{\"widgets\":[{\"type\":\"sectionHeader\",\"config\":{\"wid\":\"6c8de68c-e3d1-4f2e-86c1-bb49737fbae1\",\"sectionText\":\"<h6 style=\\\"background: #404142; padding: 5px; text-align: left;\\\"><span style=\\\"font-size: 10pt; color: #ffffff;\\\"><strong>Related Indicators<\/strong><\/span><\/h6>\",\"query\":{\"filters\":[],\"sort\":[],\"limit\":10},\"editorType\":\"html\"}},{\"type\":\"readonlyFormGroup\",\"config\":{\"wid\":\"68090a5d-4a16-4e59-a19f-c6f0b1837bc3\",\"query\":{\"sort\":[],\"limit\":10,\"logic\":\"AND\",\"filters\":[{\"field\":\"warrooms.id\",\"operator\":\"eq\",\"_operator\":\"eq\",\"value\":\"{{warRoomID}}\",\"type\":\"primitive\"}]},\"rows\":[{\"columns\":[{\"fields\":[{\"name\":\"typeofindicator\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-4\"},{\"fields\":[{\"name\":\"value\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-4\"},{\"fields\":[{\"name\":\"reputation\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-4\"}]}],\"resource\":\"indicators\",\"style\":\"display-inline-block\",\"displayType\":\"card-view\",\"gridColumns\":[],\"widgetAlwaysDisplay\":true,\"recordTitle\":{\"type\":\"sectionHeader\",\"wid\":\"f89874f5-3ebc-4e79-b176-d3b466026efe\",\"clone\":false,\"remove\":false},\"relatedTemplate\":{\"type\":\"rows\",\"rows\":[],\"wid\":\"55a8be4b-5fca-4cb9-90f9-8d1a61e86793\"}}}],\"style\":\"col-lg-12\"}],\"wid\":\"ca9d2f12-f558-459e-a30a-05602d11d32b\",\"container\":true,\"_collapsed\":false},{\"columns\":[{\"widgets\":[{\"type\":\"sectionHeader\",\"config\":{\"wid\":\"644edf16-9009-440b-83f5-a6727f2bfea5\",\"sectionText\":\"<h6 style=\\\"background: #404142; padding: 5px; text-align: left;\\\"><span style=\\\"font-size: 10pt; color: #ffffff;\\\"><strong>Related Assets<\/strong><\/span><\/h6>\",\"query\":{\"filters\":[],\"sort\":[],\"limit\":10},\"editorType\":\"html\"}},{\"type\":\"readonlyFormGroup\",\"config\":{\"wid\":\"b9c9f668-db3c-4976-8bc8-ffbac17a4ee0\",\"query\":{\"sort\":[],\"limit\":10,\"logic\":\"AND\",\"filters\":[{\"field\":\"warrooms.id\",\"operator\":\"eq\",\"_operator\":\"eq\",\"value\":\"{{warRoomID}}\",\"type\":\"primitive\"}]},\"rows\":[{\"columns\":[{\"fields\":[{\"name\":\"hostname\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-4\"},{\"fields\":[{\"name\":\"status\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-4\"},{\"fields\":[{\"name\":\"propertyOf\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-4\"}]}],\"resource\":\"assets\",\"style\":\"display-inline-block\",\"displayType\":\"card-view\",\"gridColumns\":[],\"widgetAlwaysDisplay\":true,\"recordTitle\":{\"type\":\"sectionHeader\",\"wid\":\"42132706-bcd0-4682-a904-27b0f639bcc9\",\"clone\":false,\"remove\":false},\"relatedTemplate\":{\"type\":\"rows\",\"rows\":[],\"wid\":\"59b1a938-9262-45df-b59d-7e7def9a70da\"}}}],\"style\":\"col-lg-12\"}],\"wid\":\"2eb5df90-9a05-4446-81b7-4d9742aa2174\",\"container\":true,\"_collapsed\":false},{\"columns\":[{\"widgets\":[{\"type\":\"sectionHeader\",\"config\":{\"wid\":\"6b282af8-51ce-4606-b0e1-2666db6bca8d\",\"query\":{\"filters\":[],\"sort\":[],\"limit\":10},\"editorType\":\"html\",\"sectionText\":\"<h5 style=\\\"background: #404142; padding: 5px; text-align: left;\\\"><span style=\\\"font-size: 12pt; color: #ffffff;\\\"><strong>PENDING TASKS<\/strong><\/span><\/h5>\"}},{\"type\":\"readonlyFormGroup\",\"config\":{\"wid\":\"5de5443d-eea7-47f1-bf1d-6a535868188e\",\"gridColumns\":[],\"displayType\":\"card-view\",\"widgetAlwaysDisplay\":true,\"query\":{\"sort\":[],\"limit\":10,\"logic\":\"AND\",\"filters\":[{\"field\":\"status\",\"operator\":\"neq\",\"value\":\"\/api\/3\/picklists\/343f4b67-e929-4205-bf95-ba5b70545fed\",\"_value\":{\"display\":\"Completed\",\"itemValue\":\"Completed\",\"@id\":\"\/api\/3\/picklists\/343f4b67-e929-4205-bf95-ba5b70545fed\"},\"type\":\"object\"},{\"field\":\"warrooms.id\",\"operator\":\"eq\",\"_operator\":\"eq\",\"value\":\"{{warRoomID}}\",\"type\":\"primitive\"}]},\"recordTitle\":{\"type\":\"sectionHeader\",\"wid\":\"76bd47ca-b63f-4571-95ca-33f0f2fc58f8\",\"clone\":false,\"remove\":false},\"relatedTemplate\":{\"type\":\"rows\",\"rows\":[],\"wid\":\"bf936b3d-53d0-4b99-abbd-9111d0516f60\"},\"rows\":[{\"columns\":[{\"fields\":[{\"name\":\"name\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-12\"}]},{\"columns\":[{\"fields\":[{\"name\":\"status\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-4\"},{\"fields\":[{\"name\":\"priority\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-4\"},{\"fields\":[{\"name\":\"assignedToPerson\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-4\"}]}],\"resource\":\"tasks\"}}],\"style\":\"col-lg-12\"}],\"wid\":\"cd62491c-589e-41b7-a88c-1bdf786338d4\",\"_collapsed\":false},{\"columns\":[{\"widgets\":[{\"type\":\"sectionHeader\",\"config\":{\"wid\":\"171f4062-daaf-43a9-9dc0-2b99c52347f8\",\"sectionText\":\"<p style=\\\"text-align: center;\\\"><span style=\\\"font-size: 10pt;\\\">Report Generated By FortiSOAR\u2122<\/span><\/p>\",\"query\":{\"filters\":[],\"sort\":[],\"limit\":10},\"editorType\":\"html\"}}],\"style\":\"col-lg-12\"}],\"wid\":\"d027f85c-fc5a-45df-9be9-09d51ede9bca\",\"container\":true,\"_collapsed\":false}],\"wid\":\"daaaadd9-c536-462a-8e54-47f8d9897aff\"}', '[{\"key\": \"warRoomID\", \"open\": true, \"type\": \"number\", \"label\": \"War Room ID\", \"value\": 1, \"expression\": \"{{warRoomID}}\", \"defaultValue\": 1}]', '2019-04-26 07:03:39', '2021-02-08 19:37:12', '2021-02-08 20:13:14', 'Reporting');");
        $this->addSql("INSERT INTO public.generic_template (uuid, createuser, modifyuser, displayname, type, templatetype, parenttemplateid, config, filterarray, updatedate, createdate, modifydate, generictype) VALUES ('9474953f-3196-4446-a356-1f68ae89dcf9', '$actorUuid', '$actorUuid', 'War Room Summary', 'rows', 'reporting', NULL, '{\"rows\":[{\"columns\":[{\"widgets\":[{\"type\":\"sectionHeader\",\"config\":{\"wid\":\"7dde165c-b423-4d31-a018-cf0399813c00\",\"sectionText\":\"<p style=\\\"text-align: center;\\\">&nbsp;<\/p>\\n<p style=\\\"text-align: center; background: #4e94d0; padding-top: 5px;\\\"><span style=\\\"font-size: 25pt;\\\"><strong><span style=\\\"color: #efefee;\\\">War Room Summary Report<\/span>&nbsp;<\/strong><\/span><\/p>\\n<p style=\\\"background: #2a5173; padding: 5px; text-align: center;\\\"><span style=\\\"font-size: 12pt; color: #efefee;\\\">War Room ID # <strong>{{warRoomID}}<\/strong> | Generated On {{todayDate}}<\/span><\/p>\",\"query\":{\"filters\":[],\"sort\":[],\"limit\":10},\"editorType\":\"html\"}}],\"style\":\"col-lg-12\"}],\"wid\":\"519727ca-5677-4a5d-954b-8c2c0de8aee5\",\"container\":false,\"_collapsed\":false},{\"columns\":[{\"widgets\":[{\"type\":\"sectionHeader\",\"config\":{\"wid\":\"28a2b32a-fa90-4524-844d-1f75d6adaa83\",\"sectionText\":\"<h4 style=\\\"background: #404142; padding: 5px; text-align: left;\\\"><span style=\\\"font-size: 12pt; color: #ffffff;\\\"><strong>WAR ROOM HIGHLIGHTS<\/strong><\/span><\/h4>\",\"query\":{\"filters\":[],\"sort\":[],\"limit\":10},\"editorType\":\"html\"}},{\"type\":\"readonlyFormGroup\",\"config\":{\"wid\":\"be59f9c2-0bbd-4d03-888a-1d3f1a2afa35\",\"rows\":[{\"columns\":[{\"fields\":[{\"name\":\"title\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true},{\"name\":\"summary\",\"highlightMode\":true,\"linky\":true,\"readOnly\":true}],\"style\":\"col-lg-12\"}]}],\"resource\":\"warrooms\",\"query\":{\"sort\":[],\"limit\":30,\"logic\":\"AND\",\"filters\":[]},\"style\":\"display-inline-block\",\"displayType\":\"card-view\",\"gridColumns\":[],\"widgetAlwaysDisplay\":true,\"recordTitle\":{\"type\":\"sectionHeader\",\"wid\":\"d020de22-1caf-48bc-9ace-b3f384583a0d\",\"clone\":false,\"remove\":false},\"relatedTemplate\":{\"type\":\"rows\",\"rows\":[{\"columns\":[{\"widgets\":[{\"type\":\"simpleGrid\",\"config\":{\"wid\":\"cdec5909-b9ca-4291-86a1-893b955fd660\",\"widgetAlwaysDisplay\":true,\"query\":{\"sort\":[{\"direction\":\"ASC\",\"field\":\"modifyDate\",\"_fieldTitle\":\"Modified On\",\"_fieldName\":\"modifyDate\"}],\"limit\":10,\"logic\":\"AND\",\"filters\":[{\"field\":\"warrooms.id\",\"operator\":\"eq\",\"_operator\":\"eq\",\"value\":\"{{warRoomID}}\",\"type\":\"primitive\"}]},\"mapping\":{\"assignedToPerson\":\"\",\"columns\":{\"createUser\":{\"width\":\"10\"},\"content\":{\"width\":\"90\"}}},\"columns\":[\"createUser\",\"content\"],\"module\":\"comments\",\"title\":\"Comments\",\"enableColumnWidthConfig\":true}}]}],\"wid\":\"1088a33c-9033-4f23-b875-cc8354706a8a\"}],\"wid\":\"1897ff21-aeb7-44d3-a4dc-14e08970a077\"}}}],\"style\":\"col-lg-12\"}],\"wid\":\"f207f02d-85f5-4187-9d7e-1e0ea8741217\",\"container\":true,\"_collapsed\":false}],\"wid\":\"daaaadd9-c536-462a-8e54-47f8d9897aff\"}', '[{\"key\": \"warRoomID\", \"open\": true, \"type\": \"number\", \"label\": \"War Room ID\", \"value\": null, \"expression\": \"{{warRoomID}}\", \"defaultValue\": null}]', '2019-04-26 07:03:39', '2021-01-26 23:40:52', '2021-01-26 23:44:34', 'Reporting');");
    }

    public function down(Schema $schema) : void
    {
        $this->addSql("DELETE FROM public.picklists WHERE uuid='33b6b889-4c5c-4801-999b-6c446b9568f3'");
        $this->addSql("DELETE FROM public.picklists WHERE uuid='c2f87aed-6be3-4718-a4ac-798eaa28cfc3'");
        $this->addSql("DELETE FROM public.picklists WHERE uuid='321ad354-42ce-42b6-8636-2fa184a7dcd5'");
        $this->addSql("DELETE FROM public.picklists WHERE uuid='959021fc-c19d-4aee-8e51-5395c5029719'");

        $this->addSql("DELETE FROM public.picklists WHERE listname='e14df345-8c19-4fbd-8d27-860c765def6f'");
        $this->addSql("DELETE FROM public.picklists WHERE listname='520e35ae-c3c2-45f5-bc73-af6b9476cbeb'");
        $this->addSql("DELETE FROM public.picklists WHERE listname='30efdc50-1f3d-40d3-909f-e71386dea13e'");
        $this->addSql("DELETE FROM public.picklist_names WHERE uuid='e14df345-8c19-4fbd-8d27-860c765def6f'");
        $this->addSql("DELETE FROM public.picklist_names WHERE uuid='520e35ae-c3c2-45f5-bc73-af6b9476cbeb'");
        $this->addSql("DELETE FROM public.picklist_names WHERE uuid='30efdc50-1f3d-40d3-909f-e71386dea13e'");

        $this->addSql("DELETE FROM public.attribute_metadatas WHERE type='announcements'");
        $this->addSql("DELETE FROM public.attribute_metadatas WHERE sattrib='5d49aba4-41b6-4f91-8a56-d370bd19bf3f'");
        $this->addSql("DELETE FROM public.attribute_metadatas WHERE uuid='af4b3cba-0891-49a9-90aa-4016f0db2ba7'");
        $this->addSql("DELETE FROM public.attribute_metadatas WHERE uuid='5b55fe91-7dae-40fc-ae54-3a3da904f696'");
        $this->addSql("DELETE FROM public.staging_model_metadatas WHERE uuid='5d49aba4-41b6-4f91-8a56-d370bd19bf3f'");
        $this->addSql("DELETE FROM public.module_permissions WHERE module_uuid='46e703bf-841f-465a-8fc4-8b7f9b7e078a'");
        $this->addSql("DELETE FROM public.modules WHERE uuid='46e703bf-841f-465a-8fc4-8b7f9b7e078a'");
        $this->addSql("DELETE FROM cyops.system_view_template where uuid='modules-announcements-form';");
        $this->addSql("DELETE FROM cyops.system_view_template where uuid='modules-announcements-detail';");
        $this->addSql("DELETE FROM cyops.system_view_template where uuid='modules-announcements-list';");

        $this->addSql("DELETE FROM public.generic_template WHERE uuid='9474953f-3196-4446-a356-1f68ae89dcf9'");
        $this->addSql("DELETE FROM public.generic_template WHERE uuid='60f0c032-90e8-4026-b430-176efd5560b7'");
        
    }
}
