<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20210527085242 extends AbstractMigration
{
    public function getDescription() : string
    {
        return '';
    }

    public function up(Schema $schema) : void
    {
        // this up() migration is auto-generated, please modify it to your needs

        $this->addSql('INSERT INTO public.picklist_names (uuid, name, system, id) VALUES (\'efeaa51d-a61b-4cf5-acef-52237173d72e\', \'Auth Type\', true, 45) on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES (\'0ec67016-990f-4117-a599-7b12a259d3d3\', \'Basic Auth\', 0, NULL, NULL, 283, \'efeaa51d-a61b-4cf5-acef-52237173d72e\') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES (\'6fe3b5bb-1c50-455e-b58a-7c2154f18643\', \'Certificate Auth\', 1, NULL, NULL, 284, \'efeaa51d-a61b-4cf5-acef-52237173d72e\') on CONFLICT do nothing;');

        $fetchResults = $this->connection->fetchAllAssociative("SELECT uuid FROM staging_model_metadatas WHERE type='agents'");
        if (count($fetchResults)) {
            $agentUuid = $fetchResults[0]['uuid'];
            $this->addSql('INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, "unique", recommend) VALUES (\'4056b4aa-4c47-4064-8755-2266cd4b5f79\', \'' . $agentUuid .'\', \'{{ authType }}\', \'{"singular":"Auth Type"}\', \'picklists\', \'authType\', NULL, 3, \'picklist\', \'{"model":"picklists","query":{"logic":"AND","filters":[{"field":"listName__name","operator":"eq","value":"Auth Type"}],"sort":[{"field":"orderIndex","direction":"ASC"}]},"displayConditions":{"0ec67016-990f-4117-a599-7b12a259d3d3":{"visibility":"visible","conditions":null},"6fe3b5bb-1c50-455e-b58a-7c2154f18643":{"visibility":"visible","conditions":null}}}\', false, true, false, false, false, false, NULL, \'false\', \'{"required":true,"minlength":0,"maxlength":10485761}\', \'{"allow":false,"buttonText":"","buttonIcon":"","buttonClass":"btn btn-default btn-sm"}\', NULL, \'/api/3/picklists/0ec67016-990f-4117-a599-7b12a259d3d3\', NULL, \'true\', NULL, NULL, NULL, true, NULL, false, false);');
            $this->addSql('INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, "unique", recommend) VALUES (\'eecd9116-a0e9-49cf-9419-b953c49003fe\', \'' . $agentUuid .'\', \'{{ clientCertExpiry }}\', \'{"singular":"Client Cert Expiry"}\', \'integer\', \'clientCertExpiry\', NULL, 1, \'datetime\', NULL, true, true, false, false, false, false, NULL, \'false\', \'{"required":false,"minlength":0,"maxlength":10485761}\', \'{"allow":false,"buttonText":"","buttonIcon":"","buttonClass":"btn btn-default btn-sm"}\', NULL, NULL, NULL, \'false\', NULL, NULL, NULL, true, NULL, false, false);');
            $this->addSql('INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, "unique", recommend) VALUES (\'e73a83ae-9dd9-4cb3-b132-baa0e74f4458\', \'' . $agentUuid .'\', \'{{ clientCert }}\', \'{"singular":"Client Certificate"}\', \'string\', \'clientCert\', NULL, 24, \'textarea\', NULL, true, true, false, false, false, false, NULL, \'false\', \'{"required":[{"sort":[],"limit":30,"logic":"AND","filters":[{"field":"authType","operator":"eq","value":"\/api\/3\/picklists\/6fe3b5bb-1c50-455e-b58a-7c2154f18643","_value":{"display":"Certificate Auth","itemValue":"Certificate Auth","@id":"\/api\/3\/picklists\/6fe3b5bb-1c50-455e-b58a-7c2154f18643"},"type":"object"}]}],"minlength":0,"maxlength":10485761,"_enableRange":false}\', \'{"allow":false,"buttonText":"","buttonIcon":"","buttonClass":"btn btn-default btn-sm"}\', NULL, NULL, NULL, \'true\', NULL, NULL, NULL, true, NULL, false, false);');
            $this->addSql('INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, "unique", recommend) VALUES (\'ff0d8256-118c-4e45-8e74-b4309a149278\', \'' . $agentUuid .'\', \'{{ clientKey }}\', \'{"singular":"Client Key"}\', \'string\', \'clientKey\', NULL, 25, \'textarea\', NULL, true, true, false, false, false, false, NULL, \'false\', \'{"required":[{"sort":[],"limit":30,"logic":"AND","filters":[{"field":"authType","operator":"eq","value":"\/api\/3\/picklists\/6fe3b5bb-1c50-455e-b58a-7c2154f18643","_value":{"display":"Certificate Auth","itemValue":"Certificate Auth","@id":"\/api\/3\/picklists\/6fe3b5bb-1c50-455e-b58a-7c2154f18643"},"type":"object"}]}],"minlength":0,"maxlength":10485761,"_enableRange":false}\', \'{"allow":false,"buttonText":"","buttonIcon":"","buttonClass":"btn btn-default btn-sm"}\', NULL, NULL, NULL, \'true\', NULL, NULL, NULL, true, NULL, false, false);');
        }
        $fetchResults = $this->connection->fetchAllAssociative("SELECT uuid FROM staging_model_metadatas WHERE type='routers'");
        if (count($fetchResults)) {
            $routerUuid = $fetchResults[0]['uuid'];
            $this->addSql('INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, "unique", recommend) VALUES (\'05038a75-1f21-4def-95ce-39ce407f5281\', \'' . $routerUuid .'\', \'{{ clientKey }}\', \'{"singular":"Exchange Event Listener CLient Key"}\', \'string\', \'clientKey\', NULL, 13, \'text\', NULL, false, true, false, false, false, false, NULL, \'false\', \'{"required":false,"minlength":0,"maxlength":10485761}\', \'{"allow":false,"buttonText":"","buttonIcon":"","buttonClass":"btn btn-default btn-sm"}\', NULL, \'\', \'Provide a pair of Exchange Client Cert and Exchange Client Key if mTLS is enabled at the Secure Message Exchange configuration\', \'true\', NULL, NULL, NULL, true, NULL, false, false);');
            $this->addSql('INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, "unique", recommend) VALUES (\'66155cd0-1527-444f-beaf-3d6042138d8e\', \'' . $routerUuid .'\', \'{{ clientCert }}\', \'{"singular":"Exchange Event Listener Client Cert"}\', \'string\', \'clientCert\', NULL, 14, \'text\', NULL, false, true, false, false, false, false, NULL, \'false\', \'{"required":false,"minlength":0,"maxlength":10485761}\', \'{"allow":false,"buttonText":"","buttonIcon":"","buttonClass":"btn btn-default btn-sm"}\', NULL, \'\', \'Provide a pair of Exchange Client Cert and Exchange Client Key if mTLS is enabled at the Secure Message Exchange configuration\', \'true\', NULL, NULL, NULL, true, NULL, false, false);');

        }
        $this->addSql("alter table agents add column if not exists auth_type varchar(150);");
        $this->addSql("update agents set auth_type='0ec67016-990f-4117-a599-7b12a259d3d3';");
    }

    public function down(Schema $schema) : void
    {
        // this down() migration is auto-generated, please modify it to your needs
        $this->addSql("DELETE FROM public.attribute_metadatas WHERE uuid in ('eecd9116-a0e9-49cf-9419-b953c49003fe', 'e73a83ae-9dd9-4cb3-b132-baa0e74f4458', 'ff0d8256-118c-4e45-8e74-b4309a149278', '4056b4aa-4c47-4064-8755-2266cd4b5f79', '05038a75-1f21-4def-95ce-39ce407f5281', '66155cd0-1527-444f-beaf-3d6042138d8e')");
        $this->addSql("DELETE FROM public.picklists where uuid in ('0ec67016-990f-4117-a599-7b12a259d3d3', '6fe3b5bb-1c50-455e-b58a-7c2154f18643')");
        $this->addSql("DELETE FROM public.picklist_names where uuid='efeaa51d-a61b-4cf5-acef-52237173d72e'");
    }
}
