<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use App\Entity\Workflow\Workflow;
use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20210609222917 extends AbstractMigration implements ContainerAwareInterface
{

     /** @var ContainerInterface */
    private $container;

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }
    
    public function getDescription() : string
    {
        return '';
    }

    private function setWorkflowActive($workflowUuid, $isActive)
    {
        /** @var ResourceInterface $workflowResource */
        $workflowResource = Workflow::class;
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource);
        /** @var Workflow */
        $workflowToUpdate = $workflowManager->find($workflowResource, $workflowUuid);
        if ($workflowToUpdate == null) {
            $workflowManager->flush();
            return;
        }
        $workflowToUpdate->setIsActive($isActive);
        $workflowManager->persist($workflowToUpdate);
        $workflowManager->flush();
    }

    public function up(Schema $schema) : void
    {
        $uuid = '91facde8-08e1-4700-9be1-3c835a1a17e3';
        $this->setWorkflowActive($uuid, false);
    }

    public function down(Schema $schema) : void
    {
        $uuid = '91facde8-08e1-4700-9be1-3c835a1a17e3';
        $this->setWorkflowActive($uuid, true);
    }
}
