<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20210617055910 extends AbstractMigration
{
    public function getDescription() : string
    {
        return 'Poeple show active users global filter';
    }

    private $peopleFilterSettings = '{
        "people": {
            "showActiveUsers": false
        }
    }';

    public function up(Schema $schema) : void
    {

        $fetchResults = $this->connection->fetchAllAssociative("select publicvalues from cyops.system_settings;");
        if (count($fetchResults)) {
            $publicValue = json_decode($fetchResults[0]['publicvalues'], true);
            if (!array_key_exists('globalFilters', $publicValue)) {
                $publicValue['globalFilters'] = json_decode($this->peopleFilterSettings, true);
                $updatedPublicValues = json_encode($publicValue);
                $this->addSql("update cyops.system_settings set publicvalues='".$updatedPublicValues."'");
            }
        }

    }

    public function down(Schema $schema) : void
    {
       // Not Needed

    }
}
