<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20210719082004 extends AbstractMigration
{
    public function getDescription() : string
    {
        return 'Default setting for workflow log vacuum';
    }

    private $PBVacuumSettings = '{
        "enabled": false,
        "ttl": "7"
    }';

    public function up(Schema $schema) : void
    {

        $fetchResults = $this->connection->fetchAllAssociative("select publicvalues from cyops.system_settings;");
        if (count($fetchResults)) {
            $publicValue = json_decode($fetchResults[0]['publicvalues'], true);
            if (!array_key_exists('workflow_vacuum_config', $publicValue)) {
                $publicValue['workflow_vacuum_config'] = json_decode($this->PBVacuumSettings, true);
                $updatedPublicValues = json_encode($publicValue);
                $this->addSql("update cyops.system_settings set publicvalues='".$updatedPublicValues."'");
            }
        }

    }

    public function down(Schema $schema) : void
    {
       // Not Needed

    }
}
