<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Symfony\Component\Yaml\Yaml;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration
 */
final class Version20210817154534 extends AbstractMigration
{
    public function getDescription(): string
    {
        return '';
    }

    public function up(Schema $schema): void
    {
        $fetchAttributeResults = $this->connection->fetchAllAssociative("select name from attribute_metadatas;");
        $parameter = Yaml::parse(file_get_contents('/opt/cyops-api/config/keywords.yaml'));
        foreach ($fetchAttributeResults as $key => $value) {
            foreach ($value as $innerindex => $innervalue) {
                if (isset($innervalue) && array_search($innervalue, $parameter['parameters']['keywords'])) {
                    $indexVal = array_search($innervalue, $parameter['parameters']['keywords']);
                    unset($parameter['parameters']['keywords'][$indexVal]);
                }
            }
        }

        $formattedParameter = Yaml::dump($parameter,4 ,2, Yaml::DUMP_OBJECT_AS_MAP);
        file_put_contents('/opt/cyops-api/config/keywords.yaml', $formattedParameter);

    }

    public function down(Schema $schema): void
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
