<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20211014182056 extends AbstractMigration
{
    public function getDescription(): string
    {
        return 'Adds queueable to select modules';
    }

    private $queueTemplate = '
    {
        "type": "fsQueueSettings",
        "clearRules": {
          "alerts": {
            "condition": {
              "sort": [],
              "limit": 10,
              "logic": "AND",
              "filters": [
                {
                  "field": "status",
                  "operator": "eq",
                  "value": "/api/3/picklists/fac53e73-8d16-4189-98d5-95fbd1555232",
                  "_value": {
                    "itemValue": "Closed",
                    "@id": "/api/3/picklists/fac53e73-8d16-4189-98d5-95fbd1555232"
                  },
                  "type": "object"
                }
              ]
            },
            "isActive": true,
            "isChangedFields": [
              "status"
            ]
          },
          "incidents": {
            "condition": {
              "sort": [],
              "limit": 10,
              "logic": "AND",
              "filters": [
                {
                  "field": "status",
                  "operator": "eq",
                  "value": "/api/3/picklists/bb73fd5e-f699-11e7-8c3f-9a214cf093ae",
                  "_value": {
                    "itemValue": "Resolved",
                    "@id": "/api/3/picklists/bb73fd5e-f699-11e7-8c3f-9a214cf093ae"
                  },
                  "type": "object"
                }
              ]
            },
            "isActive": true,
            "isChangedFields": [
              "status"
            ]
          },
          "tasks": {
            "condition": {
              "sort": [],
              "limit": 10,
              "logic": "AND",
              "filters": [
                {
                  "field": "status",
                  "operator": "eq",
                  "value": "/api/3/picklists/343f4b67-e929-4205-bf95-ba5b70545fed",
                  "_value": {
                    "itemValue": "Completed",
                    "@id": "/api/3/picklists/343f4b67-e929-4205-bf95-ba5b70545fed"
                  },
                  "type": "object"
                }
              ]
            },
            "isActive": true,
            "isChangedFields": [
              "status"
            ]
          }
        },
        "gridConfigs": {
          "alerts": {
            "columns": [
              "id",
              "name",
              "status",
              "assignedTo",
              "createDate"
            ]
          },
          "incidents": {
            "columns": [
              "id",
              "name",
              "status",
              "incidentLead",
              "createDate"
            ]
          },
          "tasks": {
            "columns": [
              "id",
              "name",
              "status",
              "assignedToPerson",
              "createDate"
            ]
          }
        },
        "assigneeFields": {
          "alerts": "assignedTo",
          "incidents": "incidentLead",
          "tasks": "assignedToPerson"
        }
      }
    ';

    public function up(Schema $schema): void
    {
        $this->addSql("ALTER TABLE public.model_metadatas ADD COLUMN IF NOT EXISTS queueable BOOLEAN NOT NULL DEFAULT FALSE;");
        $this->addSql("ALTER TABLE public.staging_model_metadatas ADD COLUMN IF NOT EXISTS queueable BOOLEAN NOT NULL DEFAULT FALSE;");
        $this->addSql("UPDATE staging_model_metadatas SET queueable = true WHERE type = 'alerts';");
        $this->addSql("UPDATE staging_model_metadatas SET queueable = true WHERE type = 'incidents';");
        $this->addSql("UPDATE staging_model_metadatas SET queueable = true WHERE type = 'tasks';");
        $this->addSql("INSERT INTO public.staging_model_metadatas (uuid, displayname, descriptions, type, parenttype, tablename, ownable, userownable, queueable, trackable, taggable, peerreplicable, defaultsort, uniqueconstraint, indexable, writable, system, module, softdeleteable) VALUES ('bbb01e0f-c416-403e-b493-8fc2c953bbf8', '{{ name }}', '{\"plural\":\"Queues\",\"singular\":\"Queue\"}', 'fsr_queues', NULL, 'fsr_queues', true, false, false, true, true, false, '[]', '[]', true, false, false, 'fsr_queues', false) on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('c2fd95c2-6696-4616-8e37-ff5cece58c59', 'bbb01e0f-c416-403e-b493-8fc2c953bbf8', '{{ name }}', '{\"singular\":\"Name\"}', 'string', 'name', NULL, 1, 'text', NULL, true, true, true, false, true, false, NULL, 'false', '{\"maxlength\":1024,\"minlength\":0,\"required\":true}', '{\"allow\":false}', NULL, '', '', 'true', false, NULL, true, true, false, false, false) on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('b1186648-2bb3-4c4f-8150-304e653e2d5c', 'bbb01e0f-c416-403e-b493-8fc2c953bbf8', '{{ description }}', '{\"singular\":\"Description\"}', 'string', 'description', NULL, 2, 'textarea', NULL, true, true, true, false, true, false, NULL, 'false', '{\"maxlength\":1024,\"minlength\":0,\"required\":false}', '{\"allow\":false}', NULL, '', '', 'true', false, NULL, true, true, false, false, false) on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('414069b3-97a9-4437-b4c5-5f3e4963e6ac', 'bbb01e0f-c416-403e-b493-8fc2c953bbf8', '{{ currentRoundRobinIndex }}', '{\"singular\":\"Current Round Robin Index\"}', 'integer', 'currentRoundRobinIndex', NULL, 10, 'integer', NULL, true, true, false, false, false, false, NULL, 'false', '{\"required\":false,\"minlength\":-2147483648,\"maxlength\":10485761}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, NULL, NULL, 'true', false, NULL, true, true, NULL, false, false) on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('6e4865ea-70b6-4f64-8684-232462d5dd01', 'bbb01e0f-c416-403e-b493-8fc2c953bbf8', '{{ members }}', '{\"singular\":\"Members\"}', 'people', 'members', NULL, 4, 'manyToMany', '{\"model\":\"people\"}', false, true, true, false, false, true, 'fsrQueues', 'false', '{\"maxlength\":-1,\"minlength\":0,\"required\":false}', '{\"allow\":false}', NULL, '', '', 'true', false, NULL, true, true, false, false, false) on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('04ab11c8-f53a-4fbc-b3b5-4dc196e4d347', 'bbb01e0f-c416-403e-b493-8fc2c953bbf8', '{{ leader }}', '{\"singular\":\"Leader\"}', 'people', 'leader', NULL, 10, 'lookup', '{\"model\":\"people\"}', false, true, true, false, false, false, NULL, 'false', '{\"maxlength\":-1,\"minlength\":0,\"required\":false}', '{\"allow\":false}', '{\"hideInactive\": true}', '', '', 'true', false, NULL, true, true, false, false, false) on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('6a2f3a28-b7c1-4615-bc77-ca8abcb2e035', 'bbb01e0f-c416-403e-b493-8fc2c953bbf8', NULL, '{\"singular\":\"Active\"}', 'boolean', 'active', NULL, NULL, 'checkbox', NULL, true, true, false, false, false, false, NULL, '', '[]', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, '1', NULL, 'true', false, NULL, true, true, NULL, false, false) on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('dded641e-8c01-497f-8f4d-773b23a034dc', 'bbb01e0f-c416-403e-b493-8fc2c953bbf8', NULL, '{\"singular\":\"Draft\"}', 'boolean', 'draft', NULL, NULL, 'checkbox', NULL, true, true, false, false, false, false, NULL, '', '[]', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, '1', NULL, 'true', false, NULL, true, true, NULL, false, false) on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('367211fe-901e-4e88-b456-376cd4f3debb', 'bbb01e0f-c416-403e-b493-8fc2c953bbf8', '{{ recordTypes }}', '{\"singular\":\"Record Types\"}', 'array', 'recordTypes', NULL, 20, 'array', '{\"model\":\"people\"}', false, true, true, false, false, true, NULL, 'false', '{\"maxlength\":-1,\"minlength\":0,\"required\":false}', '{\"allow\":false}', NULL, NULL, '', 'true', false, NULL, true, true, false, false, false) on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('0ac5226f-545c-4943-a26e-441d2b7cbe4b', 'bbb01e0f-c416-403e-b493-8fc2c953bbf8', '{{ assignmentParameters }}', '{\"singular\":\"Assignment Parameters\"}', 'object', 'assignmentParameters', NULL, 20, 'object', '{\"model\":\"people\"}', false, true, true, false, false, true, NULL, 'false', '{\"maxlength\":-1,\"minlength\":0,\"required\":false}', '{\"allow\":false}', NULL, '', '', 'true', false, NULL, true, true, false, false, false) on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('d702a5ed-d2f0-4671-86ec-dc9f0e2b5269', 'bbb01e0f-c416-403e-b493-8fc2c953bbf8', '{{ assignmentMethod }}', '{\"singular\":\"Assignment Method\"}', 'string', 'assignmentMethod', NULL, 1, 'text', NULL, true, true, true, false, true, false, NULL, 'false', '{\"maxlength\":1024,\"minlength\":0,\"required\":false}', '{\"allow\":false}', NULL, 'none', '', 'true', false, NULL, true, true, false, false, false) on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('3976a972-8d9a-4205-af47-41cff58e5fb0', 'bbb01e0f-c416-403e-b493-8fc2c953bbf8', '{{ recordTypeRules }}', '{\"singular\":\"Record Type Rules\"}', 'array', 'recordTypeRules', NULL, 20, 'array', NULL, false, true, true, false, false, true, NULL, 'false', '{\"maxlength\":-1,\"minlength\":0,\"required\":false}', '{\"allow\":false}', NULL, NULL, '', 'true', false, NULL, true, true, false, false, false) on conflict do nothing;");
        
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('f39c1327-aac4-4fa2-9847-82a0330b5374', (SELECT uuid FROM public.staging_model_metadatas WHERE type='people'), '{{ fsrQueues }}', '{\"singular\":\"Queues\"}', 'fsr_queues', 'fsrQueues', NULL, 22, 'manyToMany', '{\"model\":\"fsr_queues\"}', false, true, false, false, false, true, 'members', 'true', '{\"maxlength\":-1,\"minlength\":0,\"required\":false}', '{\"allow\":false}', '[]', '', '', 'true', false, NULL, true, true, false, false, false) on conflict do nothing;");
        
        $this->addSql("INSERT INTO public.staging_model_metadatas (uuid, displayname, descriptions, type, parenttype, tablename, ownable, userownable, queueable, trackable, taggable, peerreplicable, defaultsort, uniqueconstraint, indexable, writable, system, module, softdeleteable) VALUES ('a1184182-efb3-4cd1-a529-8a8861bef544', '{{ name }}', '{\"singular\":\"Shift\",\"plural\":\"Shifts\"}', 'shifts', NULL, 'shifts', false, false, false, true, true, false, '[]', '[]', true, true, false, 'shifts', false) on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('996a3930-86d4-4279-9e60-cdd5036e4b27', 'a1184182-efb3-4cd1-a529-8a8861bef544', '{{ leader }}', '{\"singular\":\"Leader\"}', 'people', 'leader', NULL, 1, 'lookup', '{\"model\":\"people\"}', false, true, false, false, true, false, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761,\"_enableRange\":false}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', '{\"hideInactive\": true}', NULL, NULL, 'true', false, NULL, true, true, NULL, false, false) on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('276ccbcd-33fb-4b4e-8e66-a8b9a10151a2', 'a1184182-efb3-4cd1-a529-8a8861bef544', '{{ name }}', '{\"singular\":\"Name\"}', 'string', 'name', NULL, 2, 'text', NULL, true, true, false, false, true, false, NULL, 'false', '{\"required\":true,\"minlength\":0,\"maxlength\":10485761,\"_enableRange\":false}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, '', NULL, 'true', false, NULL, true, true, NULL, false, false) on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('5ffa2f44-a749-47e1-8c1b-334f21f88e42', 'a1184182-efb3-4cd1-a529-8a8861bef544', '{{ startDate }}', '{\"singular\":\"Start Date\"}', 'integer', 'startDate', NULL, 3, 'datetime', NULL, true, true, false, false, true, false, NULL, 'false', '{\"required\":true,\"minlength\":0,\"maxlength\":10485761,\"_enableRange\":false}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, NULL, NULL, 'true', false, NULL, true, true, NULL, false, false) on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('646a002d-3871-4f49-987b-f7657562dcae', 'a1184182-efb3-4cd1-a529-8a8861bef544', '{{ endDate }}', '{\"singular\":\"End Date\"}', 'integer', 'endDate', NULL, 4, 'datetime', NULL, true, true, false, false, true, false, NULL, 'false', '{\"required\":true,\"minlength\":0,\"maxlength\":10485761,\"_enableRange\":false}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, NULL, NULL, 'true', false, NULL, true, true, NULL, false, false) on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('51f95b56-c7c6-4a24-a1d7-48e3d39f3810', 'a1184182-efb3-4cd1-a529-8a8861bef544', '{{ users }}', '{\"singular\":\"Users\"}', 'people', 'users', NULL, 5, 'manyToMany', '{\"model\":\"people\"}', false, true, false, false, false, true, 'shifts', 'true', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761}', '[]', NULL, NULL, NULL, 'true', false, NULL, true, true, NULL, false, false) on conflict do nothing;");
        
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend) VALUES ('b2cf4b59-1353-407a-90fc-c12b656763e2', (SELECT uuid FROM public.staging_model_metadatas WHERE type='people'), '{{ shifts }}', '{\"singular\":\"Queues\"}', 'shifts', 'shifts', NULL, 22, 'manyToMany', '{\"model\":\"shifts\"}', false, true, false, false, false, true, 'users', 'false', '{\"maxlength\":-1,\"minlength\":0,\"required\":false}', '{\"allow\":false}', '[]', '', '', 'true', false, NULL, true, true, false, false, false) on conflict do nothing;");
        
        $this->addSql("INSERT INTO public.modules (uuid, createuser, modifyuser, type, name, system, icon, description, createdate, modifydate) VALUES ('bb14bff1-1df3-45b2-b9a4-04ea5d155915', NULL, NULL, 'fsr_queues', 'Queues', true, NULL, 'Allows interactions with the Queues Module', NULL, NULL) on conflict do nothing;");
        $this->addSql("INSERT INTO public.modules (uuid, createuser, modifyuser, type, name, system, icon, description, createdate, modifydate) VALUES ('3693ccb5-cb68-4427-8472-8fb075364cac', NULL, NULL, 'shifts', 'Shifts', true, NULL, 'Allows interactions with the Shifts Module', NULL, NULL) on conflict do nothing;");

        $assignmentAutomationConfigJson = '{"title": "Queue & Shift Management","icon": "icon icon-queue-members","require": { "module": "fsr_queues", "action": "read"},"state": { "name": "main.assignment_automation_entry"},"editMode": false}';
        $fetchResults = $this->connection->fetchAllAssociative("SELECT config FROM cyops.system_view_template WHERE uuid='app' AND type='app'");

        if (count($fetchResults)) {
            $appConfig = json_decode($fetchResults[0]['config'], true);
            $helpIndex = -1;
            foreach ($appConfig['navigation'] as $index => $navItem) {
                if ($navItem['title'] == 'Help') {
                    $helpIndex = $index;
                }
            }

            $assignmentAutomationConfig = json_decode($assignmentAutomationConfigJson, true);
            if ($helpIndex > -1) {
                $appConfig['navigation'] = array_merge(array_slice($appConfig['navigation'], 0, $helpIndex), array($assignmentAutomationConfig), array_slice($appConfig['navigation'], $helpIndex));
            } else {
                array_push($appConfig['navigation'], $assignmentAutomationConfig);
            }

            $this->addSql("update cyops.system_view_template set config='" . json_encode($appConfig) . "' WHERE uuid='app' AND type='app'");
        }

        $fetchResults = $this->connection->fetchAllAssociative("SELECT config FROM cyops.system_view_template WHERE uuid='cs_queue_management'");

        if (count($fetchResults)) {
            $appConfig = json_decode($fetchResults[0]['config'], true);
            $appConfig[] = json_decode($this->queueTemplate, true);

            $this->addSql("update cyops.system_view_template set config='" . json_encode($appConfig) . "' WHERE uuid='cs_queue_management'");
        }
    }

    public function down(Schema $schema): void
    {
        $this->addSql("DELETE FROM public.attribute_metadatas WHERE sattrib='bbb01e0f-c416-403e-b493-8fc2c953bbf8'");
        $this->addSql("DELETE FROM public.attribute_metadatas WHERE uuid='f39c1327-aac4-4fa2-9847-82a0330b5374'");
        $this->addSql("DELETE FROM public.attribute_metadatas WHERE uuid='b2cf4b59-1353-407a-90fc-c12b656763e2'");
        $this->addSql("DELETE FROM public.attribute_metadatas WHERE sattrib='a1184182-efb3-4cd1-a529-8a8861bef544'");
        $this->addSql("DELETE FROM public.attribute_metadatas WHERE name='fsrQueues'");
        $this->addSql("DELETE FROM public.attribute_metadatas WHERE name='shifts'");
        $this->addSql("DELETE FROM public.staging_model_metadatas WHERE uuid='bbb01e0f-c416-403e-b493-8fc2c953bbf8'");
        $this->addSql("DELETE FROM public.staging_model_metadatas WHERE uuid='a1184182-efb3-4cd1-a529-8a8861bef544'");
        $this->addSql("ALTER TABLE public.model_metadatas DROP COLUMN IF EXISTS queueable;");
        $this->addSql("ALTER TABLE public.staging_model_metadatas DROP COLUMN IF EXISTS queueable;");
        $this->addSql("DELETE FROM public.modules WHERE uuid='bb14bff1-1df3-45b2-b9a4-04ea5d155915';");
        $this->addSql("DELETE FROM public.modules WHERE uuid='3693ccb5-cb68-4427-8472-8fb075364cac';");

    }
}
