<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20211109160609 extends AbstractMigration
{
    public function getDescription(): string
    {
        return 'Converting all datetime fields from old timestamp(0) without time zone to timestamp (6) without time zone';
    }

    private $sql = "select col.table_schema, col.table_name, col.column_name, col.data_type from information_schema.columns col
    join information_schema.tables tab on tab.table_schema = col.table_schema
                                   and tab.table_name = col.table_name
                                   and tab.table_type = 'BASE TABLE'
where col.data_type in ('timestamp without time zone', 
                        'timestamp with time zone',
                        'time with time zone',
                        'time without time zone',
                        'interval', 'date')
      and col.table_schema not in ('information_schema', 'pg_catalog')
order by col.table_schema, col.table_name;";

    public function up(Schema $schema): void
    {
        $dateTimeFields = $this->connection->fetchAllAssociative($this->sql);
        // alter table alerts alter column assigneddate type timestamp(6) without time zone;
        foreach ($dateTimeFields as $field) {
            $prepareSql = sprintf("alter table %s alter column %s type timestamp(6) without time zone;", $field['table_schema'] . '.' . $field['table_name'], $field['column_name']);
            $this->addSql($prepareSql);
        }
    }

    public function down(Schema $schema): void
    {
        // this down() migration is auto-generated, please modify it to your needs
        // Not Needed
    }
}
