<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration
 */
final class Version20220104135607 extends AbstractMigration
{
    public function getDescription(): string
    {
        return 'solution Pack Migrations';
    }

    public function up(Schema $schema): void
    {
        //Adding Data Ingestion to Navigation.
        $dataIngestionConfig = '{"title": "Data Ingestion","icon": "icon icon-updates","require": { "module": "connectors", "action": "read"},"state": { "name": "main.dataIngestion"},"editMode": false}';
        $marketConfig = '{"title": "Content Hub","icon": "icon icon-content-hub","require": { "module": "contentHub", "action": "read"},"state": { "name": "main.marketplace"},"editMode": false}';
        $fetchResults = $this->connection->fetchAllAssociative("SELECT config FROM cyops.system_view_template WHERE uuid='app' AND type='app'");

        if (count($fetchResults)) {
            $appConfig = json_decode($fetchResults[0]['config'], true);
            foreach ($appConfig['navigation'] as $index => $navItem) {
                if ($navItem['title'] == 'Automation' && array_key_exists('items', $navItem)) {
                    foreach ($navItem['items'] as $navItemKey => $navItemValue) {
                        if ($navItemValue['title'] == "Connectors") {
                            array_push($navItem['items'], json_decode($dataIngestionConfig, true));
                            break;
                        }
                    }
                    [$navItem['items'][$navItemKey+1], $navItem['items'][count($navItem['items']) - 1]] = [$navItem['items'][count($navItem['items']) - 1], $navItem['items'][$navItemKey + 1]];
                    $appConfig['navigation'][$index]['items'] = $navItem['items'];
                    break;
                }
            }
            foreach ($appConfig['navigation'] as $index => $navItem) {
                if ($navItem['title'] == 'Widget Library') {
                    array_push($appConfig['navigation'], json_decode($marketConfig, true));
                    break;
                }
            }
            [$appConfig['navigation'][$index+1], $appConfig['navigation'][count($appConfig['navigation']) - 1]] = [$appConfig['navigation'][count($appConfig['navigation']) - 1], $appConfig['navigation'][$index + 1]];

            $this->addSql("update cyops.system_view_template set config='" . json_encode($appConfig) . "' WHERE uuid='app' AND type='app'");
        }
        $this->addSql("ALTER TABLE import_jobs ADD COLUMN IF NOT EXISTS type VARCHAR(255) NULL DEFAULT 'Import Wizard';");
        $this->addSql("ALTER TABLE export_jobs ADD COLUMN IF NOT EXISTS type VARCHAR(255) NULL DEFAULT 'Export Wizard';");
        $this->addSql("UPDATE import_jobs SET type = 'Import Wizard' WHERE type IS NULL;");
        $this->addSql("UPDATE export_jobs SET type = 'Export Wizard' WHERE type IS NULL;");
        //Adding solutionpacks permission.
        $this->addSql("INSERT INTO public.modules (uuid, type, name, system, icon, description, createdate, modifydate) VALUES ('97c4b267-43b5-4715-aa22-03d77d259165', 'solutionpacks', 'Solution Packs', true, NULL, 'Provides users permissions to install, update and delete Solution Packs.', '2022-01-04 12:06:18', '2022-01-04 12:06:18') ON CONFLICT (type) do nothing");
        //Adding solutionpacks and marketplace permission.
        $this->addSql("INSERT INTO public.modules (uuid, type, name, system, icon, description, createdate, modifydate) VALUES ('d5bf31c9-c2c6-4141-a4db-12b129a41172', 'contentHub', 'Content Hub', true, NULL, 'Allows access to the Content-Hub view', '2022-01-04 12:06:18', '2022-01-04 12:06:18') ON CONFLICT (type) do nothing");
        //Adding Required Solution Pack Category Picklist and its itemvalues. 
        $result = $this->connection->fetchAllAssociative("SELECT max(id) from picklist_names");
        $id = (int)$result[0]['max'];
        $this->addSql('INSERT INTO public.picklist_names (uuid, name, system,id) VALUES (\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\', \'Solution Pack Category\', true,' . $id . ') on CONFLICT do nothing;');

        $result = $this->connection->fetchAllAssociative("SELECT max(id) from picklists");
        $id = (int)$result[0]['max'];

        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'0fb52636-53a1-4300-a70b-8a9d380c47d8\',\'Analytics and SIEM\',1,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 1) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'dd5398a6-bcaa-4c60-8c66-8ef140ff4a21\',\'Asset Management\',2,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 2) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'f2018e7c-e295-4662-9d21-7e74a23e754c\',\'Attack surface management\',3,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 3) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'2bf1b9b5-d34a-4d25-8517-88450feb74b2\',\'Authentication\',4,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 4) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'8d149cad-bf3e-4298-8e52-6aeff980be14\',\'Automation controller\',5,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 5) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'6efaf1b8-5b47-4af7-9a90-386943f3db93\',\'Case Management\',6,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 6) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'d6249ded-4eaa-42ba-b848-84db84b70c55\',\'Cloud access security broker (CASB)\',7,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 7) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'bc7dca99-593c-4f45-a644-c2f21896e187\',\'Cloud Security\',8,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 8) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'604e7c98-1d10-4566-b540-66a1a05344c4\',\'Communication and Coordination\',9,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 9) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'5697b618-4107-4684-8866-806ba9e695d2\',\'Compliance and Reporting\',10,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 10) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'882fc785-5c03-41f6-9af6-d37d3bb25665\',\'Compute Platform\',11,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 11) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'3eaaf285-075a-49a0-931f-da3ca98bfca7\',\'Computing\',12,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 12) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'dbe019d8-4f7c-4faa-9187-25c1d256fb16\',\'Container Services\',13,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 13) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'455ef9d3-63f6-43a9-9467-8e0eaef6f53a\',\'Database\',14,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 14) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'6dd6857f-1d76-4af4-a29b-ec5c84615656\',\'Deception\',15,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 15) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'db89d659-ee5f-4208-bc77-98457623e009\',\'DevOps and Digital Operations\',16,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 16) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'c1785b08-68dd-4545-a24b-7d85e14f8203\',\'Digital assistant\',17,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 17) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'9072dc10-b195-4eaa-a5e3-70cb37657348\',\'Email Gateway\',18,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 18) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'61f11f04-7473-468b-997c-01a252eb8525\',\'Email Security\',19,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 19) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'a73c1bc2-595d-4144-bbc2-e28c7a8865fd\',\'Email Server\',20,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 20) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'f69279ca-fe0c-4ea6-baf0-f243779637d8\',\'Endpoint Security\',21,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 21) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'67a14841-001a-4fc1-93e6-a65a3ed0221c\',\'Enterprise mobility management\',22,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 22) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'65597818-3e92-4669-a2f7-65c6d7eaa302\',\'Firewall and Network Protection\',23,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 23) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'eecca1fe-4fac-424d-9365-be62b21e9372\',\'Forensics and Malware Analysis\',24,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 24) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'73c30973-6029-4ab4-97a8-86d49b65da4b\',\'FortiSOAR Essentials\',25,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 25) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'202a79e6-8ace-4b66-800d-d49afa8ba7b7\',\'Identity and Access Management\',26,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 26) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'becbba1a-b104-4c12-9f04-6463d1925f7c\',\'Insider Threat\',27,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 27) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'f366b1c7-4746-40a5-a66f-bcf91a2a8207\',\'OT & IoT Security\',28,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 28) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'a8d38bda-eba8-40e6-a591-c3a11fa57ad4\',\'IT Service Management\',29,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 29) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'7118aa7b-c6f2-4896-9d6c-df3464a60742\',\'IT Services\',30,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 30) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'bec66bba-19dd-4da6-9667-820f21911670\',\'Logging\',31,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 31) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'36ac536a-d779-47fe-b118-e84fbd570b9b\',\'Malware Analysis\',32,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 32) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'46b87c50-f495-4e4f-aeec-2bbe3c968d9a\',\'Message Queueing Service\',33,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 33) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'fe0c0163-724b-48c0-b3f1-96f3a6883556\',\'ML Service\',34,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 34) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'04606b5b-71f7-4892-8263-6bfaf7475b16\',\'Monitoring\',35,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 35) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'c6290ce4-be98-4e49-9087-38fb1f1eb281\',\'Network Security\',36,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 36) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'b93315d9-b634-4865-bc44-6d3f966ee549\',\'Query Service\',37,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 37) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'777ea1c4-6615-4b0e-9097-66738696b3e6\',\'Security Posture Management\',38,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 38) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'0bdfa5b4-c458-49b3-a421-3daa24e4e482\',\'Storage\',39,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 39) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'cec487d0-ad90-410e-a2f3-7bf9da2d414c\',\'Task Management\',40,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 40) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'a332eaf4-29f5-45fb-a8d1-98e6588fc9b7\',\'Threat Detection\',41,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 41) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'d5412df1-7d2d-4517-b5dc-f8ecacdc182e\',\'Threat Hunting and Search\',42,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 42) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'cfa2f776-75e2-4e5f-8377-a35d5ae2acea\',\'Threat Intelligence\',43,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 43) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'f53d34dc-48a4-46b1-a0d3-954e80330d9f\',\'Utilities\',44,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 44) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'414a740c-05d7-48ea-8a8f-8e1e5d419c46\',\'Vulnerability and Risk Management\',45,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 45) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'323704ef-72fd-4143-a62e-3c6f10e3e1c7\',\'Web Application\',46,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 46) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'32323e02-3bf2-487e-9d08-06a70d7b8586\',\'Breach and Attack Simulation (BAS)\',47,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 47) . ') on CONFLICT do nothing;');
        $this->addSql('INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES (\'fc694c09-0f6d-4fbc-946b-36b9aab2c6b2\',\'Ticket Management\',48,NULL,NULL,\'9ac56bf5-321f-4602-bbd6-e5a14338df2a\',' . ($id + 48) . ') on CONFLICT do nothing;');
        
    }

    public function down(Schema $schema): void
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
