<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20220309165630 extends AbstractMigration
{
    public function getDescription(): string
    {
        return 'Added Roles and Permission for Content Hub and Solution Pack';
    }

    public function up(Schema $schema): void
    {
        $roleModuleUuid = null;
        $fetchContentHubResults = $this->connection->fetchAllAssociative("SELECT uuid FROM modules WHERE type = 'contentHub'");
        $fetchRoleResults = $this->connection->fetchAllAssociative("SELECT uuid FROM roles WHERE name = 'FSR Content Hub'");
        if (count($fetchRoleResults)) {
            $roleModuleUuid = $fetchRoleResults[0]['uuid'];
        } else {
            return;
        }

        if (count($fetchContentHubResults)) {
            $contentHubModuleUuid = $fetchContentHubResults[0]['uuid'];
            $this->addSql("insert into module_permissions (uuid, module_uuid, cancreate, canexecute, canread, canupdate, candelete) values ('b548339a-d9da-4617-a3cd-da38cfdede91', '" . $contentHubModuleUuid . "', false, false, true, false, false) on conflict do nothing;");
            if ($roleModuleUuid) {
                $this->addSql("insert into role_modulepermission (role_uuid, modulepermission_uuid) values ('$roleModuleUuid', 'b548339a-d9da-4617-a3cd-da38cfdede91') on conflict do nothing");
            }
        }
        $fetchSolutionPackResults = $this->connection->fetchAllAssociative("SELECT uuid FROM modules WHERE type = 'solutionpacks'");
        if (count($fetchSolutionPackResults)) {
            $solutionPackModuleUuid = $fetchSolutionPackResults[0]['uuid'];
            $this->addSql("insert into module_permissions (uuid, module_uuid, cancreate, canexecute, canread, canupdate, candelete) values ('cf4a5ff6-8433-45d0-8a33-d672e6cc7ccb', '" . $solutionPackModuleUuid . "', true, false, true, true, false) on conflict do nothing;");
            if ($roleModuleUuid) {
                $this->addSql("insert into role_modulepermission (role_uuid, modulepermission_uuid) values ('$roleModuleUuid', 'cf4a5ff6-8433-45d0-8a33-d672e6cc7ccb') on conflict do nothing");
            }
        }

        $fetchApplianceResults = $this->connection->fetchAllAssociative("SELECT uuid FROM actors WHERE name = 'Playbook'");
        if (count($fetchApplianceResults)) {
            $applianceUuid = $fetchApplianceResults[0]['uuid'];
            $this->addSql("insert into actor_role (actor_uuid, role_uuid) values ('$applianceUuid', '$roleModuleUuid') on conflict do nothing");
        }

    }

    public function down(Schema $schema): void
    {
        $this->addSql("delete from role_modulepermission where modulepermission_uuid='cf4a5ff6-8433-45d0-8a33-d672e6cc7ccb'");
        $this->addSql("delete from role_modulepermission where modulepermission_uuid='b548339a-d9da-4617-a3cd-da38cfdede91'");
        $this->addSql("delete from module_permissions where uuid='cf4a5ff6-8433-45d0-8a33-d672e6cc7ccb'");
        $this->addSql("delete from module_permissions where uuid='b548339a-d9da-4617-a3cd-da38cfdede91'");
    }
}
