<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20220414125856 extends AbstractMigration
{
    public function getDescription(): string
    {
        return 'Migration to delete picklists with listValue set as null';
    }

    public function up(Schema $schema): void
    {
        // this up() migration is auto-generated, please modify it to your needs
        // this migration might take time
        $invalidPicklistsCount = $this->connection->fetchAllAssociative("select count(*) as count from picklists where listname is null");
        if (!empty($invalidPicklistsCount) && $invalidPicklistsCount[0]['count']) {
            $invalidPicklistsCount = $invalidPicklistsCount[0]['count'];
            for ($i = 0; $i < (int)($invalidPicklistsCount / 500) + 1; $i++) {
                $this->addSql("delete from picklists where uuid in (select uuid from picklists where listname is null limit 500)");
            }
        }
    }

    public function down(Schema $schema): void
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
