<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use PDOException;
use Doctrine\DBAL\Schema\Schema;
use App\Entity\Workflow\Workflow;
use Doctrine\Migrations\AbstractMigration;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20220607070903 extends AbstractMigration implements ContainerAwareInterface
{
    /** @var ContainerInterface */
    private $container;

    private $playbooks = '[{
        "@type": "Workflow",
        "triggerLimit": null,
        "name": "Export Records As CSV",
        "aliasName": null,
        "tag": "#FSR-Utilities",
        "description": null,
        "isActive": true,
        "debug": true,
        "singleRecordExecution": false,
        "remoteExecutableFlag": false,
        "parameters": [],
        "synchronous": false,
        "lastModifyDate": 1654059911,
        "collection": "/api/3/workflow_collections/3af01eb9-0887-415b-b7fd-4d45a9d2760f",
        "versions": [],
        "triggerStep": "/api/3/workflow_steps/e0b2b02c-946c-4171-97d9-189621f664f6",
        "steps": [
        {
            "@type": "WorkflowStep",
            "name": "Start",
            "description": null,
            "arguments": {
            "route": "51b565c9-8a40-427a-989d-407f86d88646",
            "title": "Export Records CSV",
            "resources": [],
            "inputVariables": [
                {
                "name": "query",
                "type": "object",
                "label": "Query",
                "title": "JSON",
                "usable": true,
                "tooltip": "",
                "dataType": "object",
                "formType": "object",
                "required": true,
                "_expanded": true,
                "mmdUpdate": true,
                "collection": false,
                "searchable": false,
                "templateUrl": "app/components/form/fields/json.html",
                "defaultValue": "{\n  \"sort\": [],\n  \"logic\": \"AND\",\n  \"filters\": []\n}",
                "_previousName": "",
                "lengthConstraint": false,
                "allowedGridColumn": false,
                "useRecordFieldDefault": false
                },
                {
                "name": "moduleType",
                "type": "string",
                "label": "Module Type",
                "tooltip": "",
                "dataType": "text",
                "formType": "text",
                "required": false,
                "_expanded": true,
                "defaultValue": "tasks",
                "_previousName": "",
                "useRecordFieldDefault": false
                },
                {
                "name": "userId",
                "type": "string",
                "label": "userId",
                "tooltip": "",
                "dataType": "text",
                "formType": "text",
                "required": false,
                "_expanded": false,
                "defaultValue": null,
                "_previousName": "",
                "useRecordFieldDefault": false
                },
                {
                "name": "exportFileName",
                "type": "string",
                "label": "exportFileName",
                "tooltip": "",
                "dataType": "text",
                "formType": "text",
                "required": false,
                "_expanded": true,
                "defaultValue": "tasks-records.csv",
                "_previousName": "",
                "useRecordFieldDefault": false
                },
                {
                "name": "moduleName",
                "type": "string",
                "label": "Module Name",
                "tooltip": "",
                "dataType": "text",
                "formType": "text",
                "required": false,
                "_expanded": true,
                "defaultValue": null,
                "_previousName": "",
                "useRecordFieldDefault": false
            }
            ],
            "step_variables": {
                "input": {
                "params": {
                    "query": "{{vars.request.data[\"query\"]}}",
                    "userId": "{{vars.request.data[\"userId\"]}}",
                    "moduleName": "{{vars.request.data[\"moduleName\"]}}",
                    "moduleType": "{{vars.request.data[\"moduleType\"]}}",
                    "exportFileName": "{{vars.request.data[\"exportFileName\"]}}"
                },
                "records": "{{vars.input.records}}"
                }
            },
            "_promptexpanded": true,
            "executeButtonText": "Execute",
            "noRecordExecution": true,
            "singleRecordExecution": false
            },
            "status": null,
            "top": "30",
            "left": "300",
            "stepType": "/api/3/workflow_step_types/f414d039-bb0d-4e59-9c39-a8f1e880b18a",
            "uuid": "e0b2b02c-946c-4171-97d9-189621f664f6"
        },
        {
            "@type": "WorkflowStep",
            "name": "Export Records",
            "description": null,
            "arguments": {
            "name": "Report Engine",
            "config": "904ce341-5e48-4583-a1df-80738e017137",
            "params": {
                "query": "{{vars.input.params.query}}",
                "module": "{{vars.input.params.module}}",
                "userId": "{{vars.input.params.userId}}",
                "moduleName": "{{vars.input.params.moduleName}}",
                "moduleType": "{{vars.input.params.moduleType}}",
                "exportFileName": "{{vars.input.params.exportFileName}}"
            },
            "version": "1.3.0",
            "connector": "cyops-schedule-report",
            "operation": "generate_csv_export",
            "operationTitle": "Generate CSV Export",
            "pickFromTenant": false,
            "step_variables": []
            },
            "status": null,
            "top": "126",
            "left": "655",
            "stepType": "/api/3/workflow_step_types/0bfed618-0316-11e7-93ae-92361f002671",
            "uuid": "76d224ad-ef92-4ec5-876e-366b2bfc5e26"
        }
        ],
        "routes": [  
        {
            "@type": "WorkflowRoute",
            "name": "Start -> Export Records",
            "targetStep": "/api/3/workflow_steps/76d224ad-ef92-4ec5-876e-366b2bfc5e26",
            "sourceStep": "/api/3/workflow_steps/e0b2b02c-946c-4171-97d9-189621f664f6",
            "label": null,
            "isExecuted": false,
            "uuid": "fba957b3-97a5-4a87-9beb-d8ba8ca8167b"
        }
        ],
        "priority": "/api/3/picklists/2b563c61-ae2c-41c0-a85a-c9709585e3f2",
        "uuid": "0faecebd-d4ce-49b5-b90e-f4134e5414b5",
        "id": 481,
        "createUser": "",
        "createDate": 1653986478.870906,
        "modifyUser": "",
        "modifyDate": 1654059911.676492,
        "owners": [],
        "isPrivate": false,
        "deletedAt": null,
        "importedBy": [],
        "recordTags": []
    }]';

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    public function getDescription(): string
    {
        return '';
    }

    public function up(Schema $schema): void
    {
        $playbooksToAdd = json_decode($this->playbooks, true);
        foreach ($playbooksToAdd as $playbook) {
            $this->addWorkflow($playbook);
        }
    }

    private function addWorkflow($workflow)
    {
        $workflowResource = Workflow::class;
        /** @var ManagerRegistry $objectManager */
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource);
        $conn = $workflowManager->getConnection();
        try {
            $context["ignore_field_authorization"] = true;
            $context["ignore_authorization"] = true;
            $context["groups"] = ["fsr_all", "password"];
            $context["fetch_data"] = false;
            $workflowObject = $this->container->get('serializer')->deserialize(
                json_encode($workflow),
                $workflowResource,
                'jsonld',
                $context
            );
            $conn->beginTransaction();
            $workflowManager->persist($workflowObject);
            $conn->commit();
            $workflowManager->flush();
        } catch (\Exception | PDOException $e) {
            $conn->rollback();
            $workflowManager->clear();
            return true;
        }
    }

    private function deleteWorkflow($workflow)
    {
        /** @var ResourceInterface $workflowResource */
        $workflowResource = Workflow::class;
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource);
        $workflowToDelete = $workflowManager->find($workflowResource, $workflow['uuid']);
        if ($workflowToDelete == null || empty($workflowToDelete)) {
            $workflowManager->flush();
            return;
        }
        $workflowManager->remove($workflowToDelete);
        $workflowManager->flush();
    }

    public function down(Schema $schema): void
    {
        // this down() migration is auto-generated, please modify it to your needs
        $lPlaybooks = json_decode($this->playbooks, true);
        foreach ($lPlaybooks as $playbook) {
            $this->deleteWorkflow($playbook);
        }
    }
}
