<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20220607073653 extends AbstractMigration
{
    public function getDescription(): string
    {
        return '';
    }

    public function up(Schema $schema): void
    {
        $embeddedSMEConf = '/opt/cyops-rabbitmq/configs/ssl/rabbitmq-embedded-sme.conf';
        $keySSL = 'listeners.ssl.default';
        $defaultPortSSL = '5671';
        $parsedObj = parse_ini_file($embeddedSMEConf, false, INI_SCANNER_NORMAL);
        $portSSL = $parsedObj[$keySSL] ? $parsedObj[$keySSL] : $defaultPortSSL;
        $fetchRouterResults = $this->connection->fetchAllAssociative("select uuid from staging_model_metadatas where type ='routers'");
        if (count($fetchRouterResults)) {
            $stagingRouterUuid = $fetchRouterResults[0]['uuid'];
            $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend, importedby) VALUES ('d5f5e76f-2b6e-40af-97bb-5c2be33f1c76', '" . $stagingRouterUuid . "', '{{ intraTCPPort }}', '{\"singular\":\"Intra TCP Port\"}', 'integer', 'intraTCPPort', NULL, 1, 'integer', NULL, true, true, false, false, false, false, NULL, 'false', '{\"required\":false,\"minlength\":-2147483648,\"maxlength\":10485761}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, '" . $defaultPortSSL . "', NULL, 'false', false, NULL, true, true, NULL, false, false, '[]');");
            $this->addSql("Alter table routers add column if not exists intratcpport integer default " . $defaultPortSSL . ";");
            $this->addSql("UPDATE routers SET intratcpport = " . $portSSL . " where type = '302e7cc7-3a4c-4bbc-ba2c-713f23a366d8';");
        }
    }

    public function down(Schema $schema): void
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
