<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20220928062859 extends AbstractMigration
{
    public function getDescription(): string
    {
        return 'Removing Null or blank entry fron app navigation.';
    }

    public function up(Schema $schema): void
    {
        $fetchResults = $this->connection->fetchAllAssociative("SELECT config FROM cyops.system_view_template WHERE uuid='app' AND type='app'");
        if (count($fetchResults)) {
            $appConfig = json_decode($fetchResults[0]['config'], true);
            $temp = [];
            $updateRequired = false;
            foreach ($appConfig['navigation'] as $navItem) {
                if ($navItem) {
                    if (array_key_exists('items', $navItem)) {
                        $nestedTemp = [];
                        foreach ($navItem['items'] as $nestedItem) {
                            if ($nestedItem) {
                                array_push($nestedTemp, $navItem);
                            }
                        }
                        if (count($navItem['items']) > count($nestedTemp)) {
                            $updateRequired = true;
                            $navItem['items'] = $nestedItem;
                        }
                    }
                    array_push($temp, $navItem);
                }
            }
            if (count($appConfig['navigation']) > count($temp) || $updateRequired) {
                $appConfig['navigation'] = $temp;
                $this->addSql("update cyops.system_view_template set config='" . json_encode($appConfig) . "' WHERE uuid='app' AND type='app'");
            }
        }
    }

    public function down(Schema $schema): void
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
