<?php

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20230509171617 extends AbstractMigration
{
    public function getDescription(): string
    {
        return '';
    }

    public function up(Schema $schema): void
    {

        $fetchLeaveScheduleResult = $this->connection->fetchAllAssociative("SELECT uuid FROM staging_model_metadatas WHERE TYPE = 'leave_schedules';");

        if (count($fetchLeaveScheduleResult) > 0) {
            $leaveUuid = $fetchLeaveScheduleResult[0]['uuid'];
        } else {
            // this up() migration is auto-generated, please modify it to your needs
            $this->addSql("INSERT INTO public.staging_model_metadatas (uuid, displayname, descriptions, type, parenttype, tablename, ownable, userownable, queueable, trackable, taggable, peerreplicable, defaultsort, uniqueconstraint, indexable, writable, system, module, softdeleteable, archivable, paused, partitionby, archivalcriteria, archivalfilters, importedby) VALUES ('998144db-6ce3-4d5e-bf54-00e51aeee9b6', '{{name}}', '{\"plural\":\"Leave Schedules\",\"singular\":\"Leave Schedule\"}', 'leave_schedules', NULL, 'leave_schedule', false, false, false, true, true, false, '[]', '[]', true, true, true, 'leave_schedules', false, false, false, 'modifyDate', '{\"delete_primary_data_after\":60,\"keep_primary_data_for\":24}', '[]', '[]') on conflict do nothing;");
            $leaveUuid = '998144db-6ce3-4d5e-bf54-00e51aeee9b6';
        }

        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend, skipserialization, importedby) VALUES ('0a7d75d4-ca4c-45e4-a1c7-a71d13a218f8', '" . $leaveUuid . "', '{{ toDate }}', '{\"singular\":\"To Date\"}', 'integer', 'toDate', NULL, 3, 'datetime', NULL, true, false, true, false, true, false, NULL, 'false', '{\"maxlength\":10485761,\"minlength\":0,\"required\":true}', '{\"allow\":false,\"buttonClass\":\"btn btn-default btn-sm\",\"buttonIcon\":\"\",\"buttonText\":\"\"}', NULL, NULL, NULL, 'true', false, NULL, true, true, NULL, false, false, false, '[]') on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend, skipserialization, importedby) VALUES ('40357b8d-9625-4dec-8965-e84960d02076', '" . $leaveUuid . "', '{{ additionalInformation }}', '{\"singular\":\"Additional Information\"}', 'string', 'additionalInformation', NULL, 4, 'text', NULL, true, false, true, false, true, false, NULL, 'false', '{\"maxlength\":10485761,\"minlength\":0,\"required\":false}', '{\"allow\":false,\"buttonClass\":\"btn btn-default btn-sm\",\"buttonIcon\":\"\",\"buttonText\":\"\"}', NULL, '', NULL, 'true', false, NULL, true, true, NULL, false, false, false, '[]') on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend, skipserialization, importedby) VALUES ('60db1e83-1699-4722-92b8-a46eb46a920d', '" . $leaveUuid . "', '{{ fromDate }}', '{\"singular\":\"From Date\"}', 'integer', 'fromDate', NULL, 2, 'datetime', NULL, true, false, true, false, true, false, NULL, 'false', '{\"maxlength\":10485761,\"minlength\":0,\"required\":true}', '{\"allow\":false,\"buttonClass\":\"btn btn-default btn-sm\",\"buttonIcon\":\"\",\"buttonText\":\"\"}', NULL, NULL, NULL, 'true', false, NULL, true, true, NULL, false, false, false, '[]') on conflict do nothing;");
        $this->addSql("INSERT INTO public.attribute_metadatas (uuid, sattrib, displayname, descriptions, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, htmlescape, orphanremoval, readable, writeable, identifier, \"unique\", recommend, skipserialization, importedby) VALUES ('ca773e51-ff44-46a0-b5c9-1a9e058b19fa', '" . $leaveUuid . "', '{{ analyst }}', '{\"singular\":\"Analyst\"}', 'people', 'analyst', NULL, 1, 'lookup', '{\"model\":\"people\"}', false, false, true, false, true, false, NULL, 'false', '{\"_enableRange\":false,\"maxlength\":10485761,\"minlength\":0,\"required\":true}', '{\"allow\":false,\"buttonClass\":\"btn btn-default btn-sm\",\"buttonIcon\":\"\",\"buttonText\":\"\"}', '{\"hideInactive\":true,\"modulePermissions\":\"leave_schedules\",\"modulePermissionsType\":[]}', NULL, NULL, 'true', false, NULL, true, true, NULL, false, false, false, '[]') on conflict do nothing;");

        $this->addSql("INSERT INTO public.modules (uuid, createuser, modifyuser, type, name, system, icon, description, createdate, modifydate) VALUES ('998144db-6ce3-4d5e-bf54-00e51aeee9b6', NULL, NULL, 'leave_schedules', 'Leave Schedules', true, NULL, 'Allows to add leave schedules to shit management.', '2023-05-09 10:40:14.15262', '2023-05-09 10:40:14.15262') on conflict do nothing;");

        $this->addSql("INSERT INTO cyops.system_view_template (uuid, type, config, importedby) VALUES ('modules-leave_schedules-list', 'rows', '{\"rows\":[{\"columns\":[{\"widgets\":[{\"type\":\"grid\",\"config\":{\"wid\":\"3be8544b-f080-4687-863d-3b0f411213a9\",\"module\":\"leave_schedules\",\"columns\":[\"id\",\"analyst\",\"fromDate\",\"toDate\",\"additionalInformation\"],\"expandableCol\":[{\"openTab\":false,\"name\":\"additionalInformation\"}],\"relationshipField\":[],\"checkboxStatus\":false,\"editableFields\":false,\"actionButtons\":[],\"query\":{\"sort\":[],\"limit\":30,\"logic\":\"AND\",\"filters\":[]},\"enableHorizontalScroll\":true}}],\"style\":\"col-lg-12\"}],\"wid\":\"544a83d4-4be2-4751-9333-546cca580358\",\"_collapsed\":false}],\"wid\":\"c29884bb-f1ca-41c0-89b2-315e7d1275a0\",\"metadata\":{\"customTemplateTitle\":\"Leave Schedules\",\"originalTemplateTitle\":\"Leave Schedules\"}}', '[]') on conflict do nothing;");
        $this->addSql("INSERT INTO cyops.system_view_template (uuid, type, config, importedby) VALUES ('modules-leave_schedules-detail', 'rows', '{\"rows\":[{\"columns\":[{\"widgets\":[{\"type\":\"editableFormGroup\",\"config\":{\"wid\":\"842d8ed9-5e79-4a3a-99ff-592f35b72e8e\",\"rows\":[{\"columns\":[{\"fields\":[{\"name\":\"analyst\",\"highlightMode\":true,\"readOnly\":false}]}]}]}}],\"style\":\"col-lg-4\"},{\"widgets\":[{\"type\":\"editableFormGroup\",\"config\":{\"wid\":\"dce297cf-ff49-40be-91a5-98d8db7c2a0b\",\"rows\":[{\"columns\":[{\"fields\":[{\"name\":\"fromDate\",\"highlightMode\":true,\"readOnly\":false}]}]}]}}],\"style\":\"col-lg-4\"},{\"widgets\":[{\"type\":\"editableFormGroup\",\"config\":{\"wid\":\"ebfe51a6-fb6f-4050-8dcd-e75149c770a4\",\"rows\":[{\"columns\":[{\"fields\":[{\"name\":\"toDate\",\"highlightMode\":true,\"readOnly\":false}]}]}]}}],\"style\":\"col-lg-4\"}],\"wid\":\"81b1179a-d217-417e-ba6f-6a39d500452d\",\"collapsible\":false,\"collapsibleIndex\":0,\"_collapsed\":false},{\"columns\":[{\"widgets\":[{\"type\":\"editableFormGroup\",\"config\":{\"wid\":\"ccd3f413-47c3-4c14-827c-fd46cf35c4ba\",\"rows\":[{\"columns\":[{\"fields\":[{\"name\":\"additionalInformation\",\"highlightMode\":true,\"readOnly\":false}]}]}]}}],\"style\":\"col-lg-12\"}],\"wid\":\"0079ec94-6c64-438f-a9cd-238fde13ddef\",\"_collapsed\":false}],\"actionButtons\":[],\"wid\":\"ba8993cf-b52d-4ba3-baf0-0911ec0fff44\",\"metadata\":[]}', '[]') on conflict do nothing;");
    }

    public function down(Schema $schema): void
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
