<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Providers;


interface CacheableInterface
{
    /**
     * @param string $cacheKey
     * @return int
     * @throws \Exception
     */
    public function cacheContains($cacheKey);

    /**
     * @param string $cacheKey
     * @return bool|false|mixed
     * @throws \Exception
     */
    public function getFromCache($cacheKey);

    /**
     * @param string $cacheKey
     * @param mixed $value
     * @param int $lifeTime
     * @throws \Exception
     */
    public function persistToCache($cacheKey, $value, $lifeTime = 0);

    /**
     * @param string $cacheKey
     * @throws \Exception
     */
    public function deleteFromCache($cacheKey);

    /**
     * @throws \Exception
     */
    public function clearCache();
}
