<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */


namespace App\Query;

use App\Query\ExpressionInterface;


class Query implements ExpressionInterface
{
  
    /**
     * @param string $logic
     * @param ExpressionInterface[] $filters
     */
    public function __construct(protected $logic, protected $filters = [], protected $sort = [])
    {
    }

    /**
     * @param ExpressionInterface $filter
     * @return self
     */
    public function addFilter($filter)
    {
        $this->filters[] = $filter;
        return $this;
    }

    public function addSort($sort)
    {
        if ($sort) {
            $this->sort[] = $sort;
        }
        return $this;
    }

    public function toArray()
    {
        return [
            'sort' => $this->sort,
            'logic' => $this->logic,
            'filters' => array_map(fn(ExpressionInterface $filter) => $filter->toArray(), $this->filters) //arrow-functions
        ];
    }
}
