<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Repository;


use App\Entity\Core\Picklist;
use Doctrine\Persistence\ManagerRegistry;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;

/**
 * @method Picklist|null find($id, $lockMode = null, $lockVersion = null)
 * @method Picklist|null findOneBy(array $criteria, array $orderBy = null)
 * @method Picklist[]    findAll()
 * @method Picklist[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 */
class PicklistRepository extends ServiceEntityRepository
{
  public const RELATIONSHIP_SQL_GENERIC_QUERY = "INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname, id) VALUES  %s ON CONFLICT DO nothing";
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Picklist::class);
    }

    /**
     * @param $userId
     */
  // Expected input array with keys and all are required [uuid, itemvalue, orderindex, color, icon, listname]
  public function upsertPicklist(array $items)
  {
    if (empty($items)) {
      return [];
    }
    $sqlParams = [];
    $sqlValue = "";
    $id = $this->getEntityManager()->getConnection()->fetchAllAssociative('SELECT max(id) from picklists');
    $id = $id[0]['max'];
    foreach ($items as $index => $value) {
      if (!$value["itemValue"]) {
        continue;
      }
      $id = $id + 1;
      $sqlValue = '(:uuid' . $index . ',:itemvalue' . $index . ',:orderindex' . $index . ',:color' . $index . ',:icon' . $index . ',:listname' . $index . ',:id' . $index . ')';
      $sqlParams['uuid' . $index] = $value["uuid"];
      $sqlParams['itemvalue' . $index] = $value["itemValue"];
      $sqlParams['orderindex' . $index] = $value["orderIndex"];
      $sqlParams['color' . $index] = $value["color"];
      $sqlParams['icon' . $index] = $value["icon"];
      $sqlParams['id' . $index] = $id;
      $sqlParams['listname' . $index] = $value["listName"];
    }
    $finalQuery = sprintf(self::RELATIONSHIP_SQL_GENERIC_QUERY, $sqlValue);
    $this->getEntityManager()->getConnection()->executeQuery($finalQuery, $sqlParams);
  }
}
