<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Repository;


use App\Entity\Core\Tag;
use Doctrine\Persistence\ManagerRegistry;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;

/**
 * @method Tag|null find($id, $lockMode = null, $lockVersion = null)
 * @method Tag|null findOneBy(array $criteria, array $orderBy = null)
 * @method Tag[]    findAll()
 * @method Tag[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 */
class TagRepository extends ServiceEntityRepository
{

    public const RELATIONSHIP_SQL_GENERIC_QUERY = "INSERT INTO %s (%s) VALUES %s ON CONFLICT DO nothing";

    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Tag::class);
    }

    public function upsertTag($tags)
    {
        $sqlParams = [];
        $sqlValue = [];
        foreach ($tags as $index=>$value) {
            $sqlValue[] = '(:tags' . $index . ')';
            $sqlParams['tags' . $index] = $value;
        }
        $finalQuery = sprintf(self::RELATIONSHIP_SQL_GENERIC_QUERY, 'tags', 'uuid', implode(',', $sqlValue));
        $this->getEntityManager()->getConnection()->executeQuery($finalQuery, $sqlParams);
    }
}
