<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Serializer\Normalizer;

use App\Entity\Actors\Actor;
use App\Entity\Custom\Person;
use App\Entity\Custom\Appliance;
use App\Entity\Authorization\Team;

final class TeamNormalizer extends EfficientItemNormalizer
{

    public function normalize($object, $format = null, array $context = [])
    {
        if (array_key_exists('object_class', $context) && ($context['object_class'][0] == Actor::class || $context['object_class'][0] == Person::class || $context['object_class'][0] == Appliance::class)) {
            return $this->iriConverter->getIriFromItem($object);
        }
        $context['ignore_depth'] = false;
        return parent::normalize($object, $format, $context);
    }

    public function supportsNormalization($data, $format = null, array $context = []): bool
    {
        return 'jsonld' === $format && ($data instanceof Team);
    }

    /**
     * {@inheritdoc}
     */
    public function supportsDenormalization($data, $type, $format = null, array $context = [])
    {
        return false;
    }
}
