<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Service;


use Symfony\Component\Security\Core\Authentication\Token\Storage\TokenStorageInterface;
use Symfony\Component\Security\Core\Authentication\Token\TokenInterface;

abstract class AbstractUserDataProvider implements UserDataProviderInterface
{
    /** @var TokenStorageInterface */
    protected $tokenStorage;

    public function __construct(TokenStorageInterface $tokenStorage)
    {
        $this->tokenStorage = $tokenStorage;
    }

    /**
     * @inheritdoc
     */
    public function getDataForToken(TokenInterface $token)
    {
        $user = $token->getUser();
        return $this->getDataForActor($user);
    }

    /**
     * @inheritdoc
     */
    public function getDataForCurrentUser()
    {
        $token = $this->tokenStorage->getToken();
        return $this->getDataForToken($token);
    }
}
