<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Service;

/**
 * Created by PhpStorm.
 * User: Alok-Agarwal
 * Date: 5/22/18
 * Time: 7:46 PM
 */

use OldSound\RabbitMqBundle\Provider\ConnectionParametersProviderInterface;

class ConnectionParametersProviderService implements ConnectionParametersProviderInterface
{
    public function getConnectionParameters()
    {
        $mqCredObj = parse_ini_file('/opt/cyops/configs/rabbitmq/rabbitmq_users.conf', false, INI_SCANNER_NORMAL);
        $rabbitMqUsername = $mqCredObj['cyops.rabbitmq.user'] ? $mqCredObj['cyops.rabbitmq.user'] : 'guest';
        $rabbitMqPassword = $mqCredObj['cyops.rabbitmq.password'] ? $mqCredObj['cyops.rabbitmq.password'] : 'guest';
        $rabbitMqHost = $mqCredObj['cyops.rabbitmq.host'] ? $mqCredObj['cyops.rabbitmq.host'] : 'localhost';
        $rabbitMqPort = $mqCredObj['cyops.rabbitmq.port'] ? $mqCredObj['cyops.rabbitmq.port'] : '5672';
        $rabbitMqVHost = $mqCredObj['cyops.rabbitmq.vhost'] ? $mqCredObj['cyops.rabbitmq.vhost'] : '/';
        return array('host' => $rabbitMqHost, 'port' => $rabbitMqPort, 'user' => $rabbitMqUsername, 'password' => $rabbitMqPassword, 'vhost' => $rabbitMqVHost, 'connection_timeout' => 60, 'read_write_timeout' => 60);
    }
}
