<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Service;

use ApiPlatform\Core\Api\IriConverterInterface;
use ApiPlatform\Core\Exception\ItemNotFoundException;
use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;


class IriHelper
{
    /** @var IriConverterInterface */
    private $iriConverter;

    public function __construct(IriConverterInterface $iriConverter)
    {
        $this->iriConverter =  $iriConverter;
    }

    //not very useful. just retaining same response as previous version of crudhub
    public function findOrThrowNotFound($moduleIri)
    {
        try {
            return $this->iriConverter->getItemFromIri($moduleIri);
        } catch (ItemNotFoundException $e) {
            throw new NotFoundHttpException();
        } catch (\Exception $e) {
            throw new NotFoundHttpException();
        }
    }
}
