<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Traits;
use ApiPlatform\Core\Annotation\ApiSubresource;
use Symfony\Component\Serializer\Annotation\Groups;
use App\Entity\Query\SystemQuery;

trait Filterable
{
    /**
     * @Doctrine\ORM\Mapping\ManyToMany(targetEntity=SystemQuery::class, cascade={"persist"})
     * @ApiSubresource(maxDepth=1)
     * @Groups({"fsr_all", "datasets"})
     */
    protected $datasets;

    public function addDataset(SystemQuery $dataset): self
    {
        $this->datasets[] = $dataset;
        return $this;
    }

    public function removeDataset(SystemQuery $dataset)
    {
        $this->datasets->removeElement($dataset);
        return $this;
    }

    public function getDatasets()
    {
        return $this->datasets;
    }
}
