<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Traits;

use Symfony\Component\Serializer\Annotation\Groups;
use ApiPlatform\Core\Annotation\ApiProperty;

trait Indexable
{
    /**
     * @var integer
     *
     * @Doctrine\ORM\Mapping\Column(name="id", type="bigint", nullable=false, columnDefinition="SERIAL8", insertable=false)
     * @ApiProperty(writable=false, identifier=false)
     * @Groups({"fsr_primary", "fsr_all", "id"})
     */
    protected $id;

    /**
     * Get id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }
}

