<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Traits;

use Symfony\Component\Serializer\Annotation\Groups;
use ApiPlatform\Core\Annotation\ApiProperty;

trait PeerReplicable
{
    /**
     * @Doctrine\ORM\Mapping\ManyToOne(targetEntity="Tenant", cascade={"persist"})
     * @Doctrine\ORM\Mapping\JoinColumns({
     *   @Doctrine\ORM\Mapping\JoinColumn(name="tenant", referencedColumnName="uuid", onDelete="CASCADE", columnDefinition="VARCHAR DEFAULT 'b3a700f7-00be-4ef9-90c6-3c8fe6e1be63'")
     * })
     * @ApiProperty(writable=false)
     * @Groups({"fsr_primary", "fsr_all", "tenant"})
     */
    protected $tenant;

    /**
     * @Doctrine\ORM\Mapping\Column(name="conflict", type="boolean", nullable=true)
     * @Groups({"fsr_primary", "fsr_all", "conflict"})
     */
    protected $conflict;

    /**
     * @Doctrine\ORM\Mapping\Column(name="tenantrecordid", type="integer", nullable=true)
     * @ApiProperty(writable=false)
     * @Groups({"fsr_primary", "fsr_all", "tenantRecordId"})
     */
    protected $tenantRecordId;

    public function getTenantRecordId()
    {
        if (is_null($this->tenantRecordId)) {
            return $this->getId();
        }
        return $this->tenantRecordId;
    }

    public function setTenantRecordId($tenantRecordId)
    {
        $this->tenantRecordId = $tenantRecordId;

        return $this;
    }

    public function getTenant()
    {
        return $this->tenant;
    }

    public function setTenant($tenant)
    {
        $this->tenant = $tenant;

        return $this;
    }

    public function getConflict()
    {
        return $this->conflict;
    }

    public function setConflict($conflict)
    {
        $this->conflict = $conflict;

        return $this;
    }
}
