<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Traits;


trait Queueable
{
    /**
     * @var \App\Entity\Custom\Queue
     *
     * @Doctrine\ORM\Mapping\ManyToOne(targetEntity="App\Entity\Custom\Queue", cascade={"persist"})
     * @Doctrine\ORM\Mapping\JoinColumns({
     *   @Doctrine\ORM\Mapping\JoinColumn(name="fsr_queue", referencedColumnName="uuid", onDelete="SET NULL")
     * })
     * @Groups({"fsr_primary", "fsr_all", "fsrQueue"})
     */
    protected $fsrQueue;
    

    /**
     * Set queue
     *
     * @param \App\Entity\Custom\Queue  $fsrQueue
     */
    public function setFsrQueue(\App\Entity\Custom\Queue $fsrQueue = null)
    {
        $this->fsrQueue = $fsrQueue;

        return $this;
    }

    /**
     * Get queue
     *
     * @return \App\Entity\Custom\Queue 
     */
    public function getFsrQueue()
    {
        return $this->fsrQueue;
    }
}
