<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Traits;

use Symfony\Component\Serializer\Annotation\Groups;

trait SoftDeleteable
{
    /**
     * @var \DateTime|null $deletedAt
     * @Groups({"fsr_primary", "fsr_all", "deletedAt"})
     * @Doctrine\ORM\Mapping\Column(name="deletedat", type="datetime", nullable=true, unique=false)
     */
    protected $deletedAt;

    /**
     * Get $deletedAt
     *
     * @return  \DateTime
     */ 
    public function getDeletedAt()
    {
        return $this->deletedAt;
    }

    /**
     * Set $deletedAt
     *
     * @param  \DateTime  $deletedAt  $deletedAt
     *
     * @return  self
     */ 
    public function setDeletedAt($deletedAt = null)
    {
        $this->deletedAt = $deletedAt;

        return $this;
    }
}
