<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Traits;

use App\Entity\Actors\Actor;
use Symfony\Component\Serializer\Annotation\Groups;
use ApiPlatform\Core\Annotation\ApiProperty;


trait Trackable
{
    /**
     * @Doctrine\ORM\Mapping\ManyToOne(targetEntity="App\Entity\Actors\Actor", cascade={"persist"})
     * @Doctrine\ORM\Mapping\JoinColumns({
     *   @Doctrine\ORM\Mapping\JoinColumn(name="createuser", referencedColumnName="uuid", onDelete="SET NULL")
     * })
     * @ApiProperty(writable=false)
     * @Groups({"fsr_primary", "fsr_all", "createUser"})
     */
    protected $createUser;

    /**
     * @Doctrine\ORM\Mapping\Column(name="createdate", type="datetime", nullable=true)
     * @Groups({"fsr_primary", "fsr_all", "createDate"})
     * @ApiProperty(writable=false)
     */
    protected $createDate;

    /**
     * @Doctrine\ORM\Mapping\ManyToOne(targetEntity="App\Entity\Actors\Actor", cascade={"persist"})
     * @Doctrine\ORM\Mapping\JoinColumns({
     *   @Doctrine\ORM\Mapping\JoinColumn(name="modifyuser", referencedColumnName="uuid", onDelete="SET NULL")
     * })
     * @Groups({"fsr_primary", "fsr_all", "modifyUser"})
     */
    protected $modifyUser;

    /**
     * @Doctrine\ORM\Mapping\Column(name="modifydate", type="datetime", nullable=true)
     * @Groups({"fsr_primary", "fsr_all", "modifyDate"})
     */
    protected $modifyDate;

    public function getCreateUser()
    {
        return $this->createUser;
    }
    
    public function setCreateUser($createUser)
    {
        $this->createUser = $createUser;

        return $this;
    }


    public function setCreateDate($createDate)
    {
        $this->createDate = $createDate;

        return $this;
    }

    public function getCreateDate()
    {
        return $this->createDate;
    }


    public function getModifyUser()
    {
        return $this->modifyUser;
    }

    public function setModifyUser($modifyUser)
    {
        $this->modifyUser = $modifyUser;

        return $this;
    }

    public function setModifyDate($modifyDate)
    {
        $this->modifyDate = $modifyDate;

        return $this;
    }

    public function getModifyDate()
    {
        return $this->modifyDate;
    }
}
