<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Validator;

use Symfony\Component\Validator\Constraint;

/**
 * @Annotation
 */
class CompatibilityConstraint extends Constraint
{
    const MESSAGE = "Data type conversion from Old Type : {{ old_type }}[{{ old_form_type }}] to New Type: {{ new_type }}[{{ new_form_type }}] not supported for {{ modelType }} - {{ name }} field.";
    public const DUPLICATEFIELDVIOLATION = "Duplicate field: '{{ value }}' exists in '{{ model }}' module. Do note fields name are case insensitive";
    public const PICKLISTTYPECONVERSION = "Data type conversion from Old field Type : '{{ type1 }}' to New Type: '{{ type2 }}' not supported for '{{ module }}'-'{{ name }}' field.";
    public function getTargets()
    {
        return self::CLASS_CONSTRAINT;
    }
    public function validatedBy()
    {
        return get_class($this) . 'Validator';
    }
}
