<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Validator;

use Doctrine\ORM\Mapping\Annotation;
use Symfony\Component\Validator\Constraint;

/**
 * @Annotation
 */
class DescriptionNameConstraint extends Constraint
{
    /*
     * Any public properties become valid options for the annotation.
     * Then, use these in your validator class.
     */
    public const MESSAGE = 'A module already exists with singular name {{ name }}';
    public const NON_ARCHIVABLE_MESSAGE = "Module {{ name }} cannot be enabled for Archival support as it non trackable";
    public const RESERVE_NON_ARCHIVABLE_MESSAGE = "Module {{ name }} cannot be enabled for Archival support as it is a system module.";
    public const RESERVE_NON_RECYCLEABLE_MESSAGE = "Module {{ name }} cannot be enabled for Recycle Bin support as it is a system module.";
    public const RESERVE_NON_PEER_REPLICABLE_MESSAGE = "Module {{ name }} cannot be enabled for Replication as it is a system module.";


    public function getTargets()
    {
        return self::CLASS_CONSTRAINT;
    }

    public function validatedBy()
    {
        return static::class . 'Validator';
    }
}
