<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Validator;

use Symfony\Component\Validator\Constraint;

/**
 * @Annotation
 * @Target({"PROPERTY", "METHOD", "ANNOTATION"})
 */
class KeywordConstraint extends Constraint
{
    public const MESSAGE = "Invalid field name, module type, or singular description: '{{ value }}' is a reserved keyword.";
    public const NON_STRING_MESSAGE = "Invalid field name, module type, or singular description: '{{ value }}' must be a string.";

    /** @var array */
    protected $fields;

    public function validatedBy()
    {
        return get_class($this) . 'Validator';
    }
}
