<?php
/* Copyright start
  Copyright (C) 2008 - 2023 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Validator;

use Symfony\Component\Validator\Constraint;

/**
 * @Annotation
 */
class ModelMetadataCollectionConstraint extends Constraint
{
  public const CORETYPEVIOLATION = "Type '{{ value }}' already exists as core model metadata.";
  public const ATTRIBUTETYPEVIOLATION = "Attribute type '{{ value }}' does not exist as core or custom model metadata.";
  public const INVERSEDFIELDVIOLATION = "Inverse field '{{ value }}' does not exist on related model metadata '{{ model_metadata }}'.";
  // Sample: Duplicate field fileName exist in alerts module. 
  // Do note the attribute name are case insensitive.
  // filename and fileName are considered same fields by framework.
  public const DUPLICATEFIELDVIOLATION = "Duplicate field: '{{ value }}' exists in '{{ model }}' module. Do note fields name are case insensitive";

  public const ATTRIBUTENAMEVIOLATION = "Attribute Name '{{ value }}' that exists in the '{{ model }}' module contains only numeric values. An attribute name must contain one or more alpha characters.";
  public const LOOKUPVIOLATION = "For many-to-one '{{ field }}' field in '{{ model1 }}' module there is no lookup field present in '{{ model2 }}' module.";
  public function validatedBy()
  {
    return get_class($this) . 'Validator';
  }
}
